      PROGRAM AC_MBE_P6_FD_2
      IMPLICIT NONE
      
      INTEGER sx,sy,syp1
      PARAMETER(sx=512,sy=512,syp1=sy+1)
      REAL*8 pi
      PARAMETER(pi=3.14159265358979323846264338327950288D+0)
      
C general variables

      INTEGER  n,m,i,j,kk,kkk,kkkk
      REAL*8   x(0:sx),y(0:sy),nu,re,eps,aaa



C physical variables (true solution and force terms)  

      REAL*8 phi(-2:sx+2,-2:sy+2),phi0(0:sx, 0:sy),
     *       phi1(0:sx  , 0:sy  ),
     *       px (-1:sx+1,-1:sy+1),py (-1:sx+1,-1:sy+1),
     *       dd (-1:sx+1,-1:sy+1),dlap(0:sx, 0:sy),
     *       plap(-1:sx+1,-1:sy+1),plap1(0:sx,0:sy), 
     *       fx (-1:sx+1,-1:sy+1),fy (-1:sx+1,-1:sy+1),  
     *       ftmp(0:sx, 0:sy),ftmp1(0:sx,0:sy), 
     *       phie(0:sx, 0:sy)

      REAL*8 fpe1(0:sx, 0:sy),fpe2(0:sx, 0:sy),
     *       fpe3(0:sx, 0:sy),
     *       pxe (0:sx, 0:sy),pye (0:sx, 0:sy)
     
      REAL*8 cc0,cc1,cc2,cc3,cc4,cc5,alpha


      REAL*8  eng,enge


C time variables

      INTEGER nts
      REAL*8 final_time,tfinal,cfl,dt
      REAL*8 ctime
      

C aux matrix variables

      REAL*8 aux(0:sy,0:sx),aux1(0:sy,0:sx),aux2(0:sy,0:sx), 
     *       bux(0:sx,0:sy),bux1(0:sx,0:sy),bux2(0:sx,0:sy)

      REAL*8 WSAVEX(2*sx+15),WSAVEY(2*sy+15),
     *       fmx1(0:sx),fmx2(0:sx),fmy1(0:sy),fmy2(0:sy)

      REAL*8  dx,dy,t1,t2,t3,t4,t5,t6,xlen,ylen


      ctime=0.0D+0


      CALL SETUP(n,m,sx,sy,x,y,re,nu,eps,aaa,xlen,ylen,
     &           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     &           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,     
     &           phi,phi0,phie,px,py,fx,fy,plap,ftmp,ftmp1,
     &           fpe1,fpe2,fpe3,pxe,pye,
     &           aux,aux1,aux2,bux,bux1,bux2)


C Set up the ghost point guess
      DO j=0,n
      DO i=0,m
        t1=(     phi(i-1,j-1) + phi(i-1,j+1) 
     *  - 4.0D+0*phi(i  ,j)
     *        +  phi(i+1,j-1) + phi(i+1,j+1)
     *  +2.0D+0*(phi(i-1,j  ) + phi(i+1,j  )) 
     *  -2.0D+0*(phi(i  ,j-1) + phi(i  ,j+1)))/(4.0D+0*dx*dx)
     
        t2=(     phi(i-1,j-1) + phi(i-1,j+1) 
     *  - 4.0D+0*phi(i  ,j)
     *        +  phi(i+1,j-1) + phi(i+1,j+1)
     *  -2.0D+0*(phi(i-1,j  ) + phi(i+1,j  )) 
     *  +2.0D+0*(phi(i  ,j-1) + phi(i  ,j+1)))/(4.0D+0*dy*dy)
      
        phi1(i,j)=phie(i,j)*COS(-dt)
        plap1(i,j)=t1+t2
      ENDDO
      ENDDO
      

C Time integration
      DO kk=1,nts
      
         ctime=DBLE(kk-1)*dt
           IF (MOD(kk,5) .EQ. 0) THEN
           WRITE(6,*) 'step :',kk,' time ;',ctime
         END IF
         
C Computing the energy
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=px(i,j)*px(i,j) + py(i,j)*py(i,j)
     
        t1=t1 + t2*t2*t2
      ENDDO
      ENDDO
      eng=dx*dy*t1/6.0D+0


      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=px(i,j)*px(i,j)
        t3=py(i,j)*py(i,j)
        
        t1=t1 + 0.5D+0 *(t2 + t3)
      ENDDO
      ENDDO
      eng=eng - dx*dy*t1


      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t5=plap(i,j)
        
        t1=t1 + 0.5D+0 *eps*eps*t5*t5
      ENDDO
      ENDDO
      eng=eng + dx*dy*t1
         
C Initial guess
      DO j=0,n
      DO i=0,m
        phi (i,j)=2.0D+0*phi0(i,j) - phi1(i,j)
      ENDDO
      ENDDO
      
C The force term

      t1= COS(ctime)
      t2= COS(ctime+dt)
      t3= (COS(ctime+dt) - COS(ctime))/dt
      DO j=0,n
      DO i=0,m 
        ftmp(i,j) = fpe1(i,j)*t1
     *           -  fpe2(i,j)*t2*t2*t2*t2*t2
     *           +  eps*eps*fpe3(i,j)*t2
     *           + t3*phie(i,j)
      ENDDO
      ENDDO

      

C Iteration loop

      DO kkk=1,20

         CALL Residue(n,m,sx,sy,x,y,re,nu,eps,aaa,xlen,ylen,
     *           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     *           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,
     *           phi,phi0,px,py,plap,plap1,fx,fy,
     *           ftmp,ftmp1,aux,aux1,aux2,bux,bux1,bux2)
     
     
C Solve for the search direction: dd 

      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=ftmp1(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (n,m,aux(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        bux(i,j)=aux(j,i)
      ENDDO
      ENDDO

      CALL VRFFTF (m,n,bux(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        t1=fmx2(i) + fmy2(j)
        t3=1.0D+0 + dt*eps*eps*t1*t1 - dt*t1

        bux(i,j)=bux(i,j)/t3
      ENDDO
      ENDDO

      CALL VRFFTB (m,n,bux(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=bux(i,j)
      ENDDO
      ENDDO

      CALL VRFFTB (n,m,aux(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        dd(i,j)=aux(j,i)
      ENDDO
      ENDDO
      
C Normalization in the L^2 norm
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=dd(i,j)*dd(i,j) 
        
        t1=t1 + t2
      ENDDO
      ENDDO
      t1=sqrt(dx*dy*t1)
      
      DO j=0,n-1
      DO i=0,m-1
        dd(i,j)=dd(i,j)/(t1+1.0D-14) 
      ENDDO
      ENDDO
      
C Periodic extension
      i=m
      DO j=0,n-1
        dd(m,j)=dd(0,j)
      ENDDO
      
      j=n
      DO i=0,m
        dd(i,n)=dd(i,0)
      ENDDO

CCCCCCCCCCC

         CALL Coefficient(n,m,sx,sy,x,y,re,nu,eps,aaa,xlen,ylen,
     *           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     *           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,
     *           phi,phi0,dd,dlap,plap,plap1,px,py,fx,fy,
     *           ftmp,ftmp1,aux,aux1,aux2,bux,bux1,bux2,
     *           cc0,cc1,cc2,cc3,cc4,cc5)
     
     
C Newton's iteration loop 
      alpha=0.0D+0
      DO kkkk=1,10
        t1=cc5*alpha*alpha*alpha*alpha*alpha
     *   + cc4*alpha*alpha*alpha*alpha
     *   + cc3*alpha*alpha*alpha
     *   + cc2*alpha*alpha
     *   + cc1*alpha
     *   + cc0
     
        t2=5.0D+0*cc5*alpha*alpha*alpha*alpha
     *   + 4.0D+0*cc4*alpha*alpha*alpha
     *   + 3.0D+0*cc3*alpha*alpha
     *   + 2.0D+0*cc2*alpha
     *   +        cc1
     
c       write(6,*) t1
     
        alpha=alpha - t1/t2
      ENDDO
CCCCCC

      DO j=0,n
      DO i=0,m
        phi(i,j)=phi(i,j) + alpha*dd(i,j) 
      ENDDO
      ENDDO


      END DO
      
      ctime=ctime+dt
      
      
      write(6,*) 'the time step kk=', kk

         CALL CHECK(n,m,sx,sy,x,y,re,nu,eps,ctime,dt,
     *           dx,dy,WSAVEX,WSAVEY,
     *           fmx1,fmx2,fmy1,fmy2,phi,phie,eng,enge)
      
      DO j=0,n
      DO i=0,m
        phi1 (i,j)=phi0 (i,j)
        phi0 (i,j)=phi  (i,j)
        
        t1=(     phi(i-1,j-1) + phi(i-1,j+1) 
     *  - 4.0D+0*phi(i  ,j)
     *        +  phi(i+1,j-1) + phi(i+1,j+1)
     *  +2.0D+0*(phi(i-1,j  ) + phi(i+1,j  )) 
     *  -2.0D+0*(phi(i  ,j-1) + phi(i  ,j+1)))/(4.0D+0*dx*dx)
     
        t2=(     phi(i-1,j-1) + phi(i-1,j+1) 
     *  - 4.0D+0*phi(i  ,j)
     *        +  phi(i+1,j-1) + phi(i+1,j+1)
     *  -2.0D+0*(phi(i-1,j  ) + phi(i+1,j  )) 
     *  +2.0D+0*(phi(i  ,j-1) + phi(i  ,j+1)))/(4.0D+0*dy*dy)
        
        plap1(i,j)=t1 + t2
      ENDDO
      ENDDO
      
      ENDDO


      STOP
      END
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      SUBROUTINE SETUP(n,m,sx,sy,x,y,re,nu,eps,aaa,xlen,ylen,
     &           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     &           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,     
     &           phi,phi0,phie,px,py,fx,fy,plap,ftmp,ftmp1,
     &           fpe1,fpe2,fpe3,pxe,pye,
     &           aux,aux1,aux2,bux,bux1,bux2)
      IMPLICIT NONE

      REAL*8 pi
      PARAMETER(pi=3.14159265358979323846264338327950288D+0)


      INTEGER  n,m,sx,sy,i,j,k,kk
      REAL*8   x(0:sx),y(0:sy),nu,re,eps,aaa

      REAL*8 phi(-2:sx+2,-2:sy+2),phi0(0:sx, 0:sy),
     *       px (-1:sx+1,-1:sy+1),py (-1:sx+1,-1:sy+1),
     *       plap(-1:sx+1,-1:sy+1), 
     *       fx (-1:sx+1,-1:sy+1),fy (-1:sx+1,-1:sy+1),
     *       ftmp(0:sx, 0:sy),ftmp1(0:sx,0:sy),
     *       phie(0:sx, 0:sy)

      REAL*8 fpe1(0:sx, 0:sy),fpe2(0:sx, 0:sy),
     *       fpe3(0:sx, 0:sy),
     *       pxe (0:sx, 0:sy),pye (0:sx, 0:sy)

      
      INTEGER nts
      REAL*8 final_time,tfinal,cfl,dt
      REAL*8 ctime
      REAL*8 WSAVEX(2*sx+15),WSAVEY(2*sy+15),
     *       fmx1(0:sx),fmx2(0:sx),fmy1(0:sy),fmy2(0:sy)

      REAL*8 aux(0:sy,0:sx),aux1(0:sy,0:sx),aux2(0:sy,0:sx), 
     *       bux(0:sx,0:sy),bux1(0:sx,0:sy),bux2(0:sx,0:sy)

      REAL*8  dx,dy,t1,t2,t3,t4,t5,t6,xlen,ylen

      REAL*8  phix,phiy,phixx,phiyy,phixy,
     *        phixxxx,phixxyy,phiyyyy,
     *        aaa1,aaa2,aaa3,aaa4 


C local variables
      REAL*8  aap1,aap2,aap3,aap4,aap5,aap6,aap7,aap8,
     *        a1p,a2p,emaxp


      m=sx
      n=sy

      Re=1000.0D+0
      nu=1.0D+0/re

      eps=0.5D+0
      aaa=0.5D+0 

C compute Chebyshev differentiation matrices

      xlen=1.0D+0
      ylen=1.0D+0
      dx=xlen/FLOAT(m)
      dy=ylen/FLOAT(n)
   
      DO i=0,m
         x(i)=FLOAT(i)*dx 
      END DO

      DO j=0,n
         y(j)=FLOAT(j)*dy
      END DO



C initialize for FFT
c     CALL VSINQI(m  ,WSAVESQX)
c     CALL VSINQI(n  ,WSAVESQY)
c     CALL VSINQI(nz ,WSAVESQZ)
c     CALL VCOSQI(m  ,WSAVECQX)
c     CALL VCOSQI(n  ,WSAVECQY)
c     CALL VCOSQI(nz ,WSAVECQZ)
c     CALL VSINTI(m-1,WSAVESX )
c     CALL VSINTI(m-1,WSAVESY )
c     CALL VSINTI(nz-1,WSAVESZ)

      CALL VRFFTI(m  ,WSAVEX)
      CALL VRFFTI(n  ,WSAVEY)
      
      fmx1(0)=0.0D+0
      fmx2(0)=0.0D+0
      DO j=1,m-3,2
        fmx1(j  )=-FLOAT(j+1)*pi/xlen
        fmx1(j+1)=-fmx1(j)
        fmx2(j  )=-FLOAT(j+1)*FLOAT(j+1)*pi*pi/(xlen*xlen)
        t1=0.5D+0*FLOAT(j+1)*pi*dx/xlen
        fmx2(j  )= -4.0D+0*SIN(t1)*SIN(t1)/(dx*dx)
        fmx2(j+1)= fmx2(j)
      ENDDO
      fmx1(m-1)=-FLOAT(m)*pi/xlen
      fmx2(m-1)=-FLOAT(m)*FLOAT(m)*pi*pi/(xlen*xlen)
      t1=0.5D+0*FLOAT(m)*pi*dx/xlen
      fmx2(m-1)= -4.0D+0*SIN(t1)*SIN(t1)/(dx*dx)
      

      fmy1(0)=0.0D+0
      fmy2(0)=0.0D+0
      DO j=1,n-3,2
        fmy1(j  )=-FLOAT(j+1)*pi/ylen
        fmy1(j+1)=-fmy1(j)
        fmy2(j  )=-FLOAT(j+1)*FLOAT(j+1)*pi*pi/(ylen*ylen)
        t1=0.5D+0*FLOAT(j+1)*pi*dy/ylen
        fmy2(j  )= -4.0D+0*SIN(t1)*SIN(t1)/(dy*dy)
        fmy2(j+1)= fmy2(j)
      ENDDO
      fmy1(n-1)=-FLOAT(n)*pi/ylen
      fmy2(n-1)=-FLOAT(n)*FLOAT(n)*pi*pi/(ylen*ylen)
      t1=0.5D+0*FLOAT(n)*pi*dy/ylen
      fmy2(n-1)= -4.0D+0*SIN(t1)*SIN(t1)/(dy*dy)
      
      
C time stepping 
      cfl=0.5D+0
      dt=cfl*DMIN1(dx,dy)
      dt=0.01D+0
      final_time=1.0D+0
      nts=IDINT(final_time/dt)
      tfinal=DBLE(nts)*dt

      WRITE(6,*) ' '
      WRITE(6,*) 'tfinal, nts, dt :',tfinal,nts,dt
      WRITE(6,*) ' '


C Initial data
      
      DO j=0,n
      DO i=0,m
        phie(i,j) =   1.0D+0/(2.0D+0*pi) 
     *              * SIN(2.0D+0*pi*(x(i)-0.5D+0*dx)  ) 
     *              * COS(2.0D+0*pi*(y(j)-0.5D+0*dy)  )

        phi (i,j)=phie(i,j)
        
        phi0(i,j)=phie(i,j)
      ENDDO
      ENDDO
      
      DO j=0,n
        phi( -1,j)=phi(m-1,j)
        phi( -2,j)=phi(m-2,j)
        phi(m+1,j)=phi(  1,j)
        phi(m+2,j)=phi(  2,j)
      ENDDO
      
      DO i=-2,m+2
        phi(i, -1)=phi(i,n-1)
        phi(i, -2)=phi(i,n-2)
        phi(i,n+1)=phi(i,  1)
        phi(i,n+2)=phi(i,  2)
      ENDDO
      
      
C Taking phi_x     
      DO j=-1,n
      DO i=-1,m
        phix = (phi(i+1,j  ) - phi(i,j  )
     *         +phi(i+1,j+1) - phi(i,j+1))/(2.0D+0*dx)
    
        px (i,j)=phix
      ENDDO
      ENDDO
      
      DO j=0,n
      DO i=0,m
        pxe(i,j)=px(i,j)
      ENDDO
      ENDDO
      
C Taking phi_y
      DO j=-1,n
      DO i=-1,m
        phiy = (phi(i  ,j+1) - phi(i  ,j)
     *         +phi(i+1,j+1) - phi(i+1,j))/(2.0D+0*dy)
     
        py (i,j)=phiy
      ENDDO
      ENDDO
      
      DO j=0,n
      DO i=0,m
        pye(i,j)=py(i,j)
      ENDDO
      ENDDO
      
C Taking \Delta \phi
      DO j=-1,n+1
      DO i=-1,m+1
        t1=(     phi(i-1,j) 
     *  - 2.0D+0*phi(i  ,j)
     *    +      phi(i+1,j))/(dx*dx)
     
        t2=(     phi(i,j-1) 
     *  - 2.0D+0*phi(i,j  )
     *    +      phi(i,j+1))/(dy*dy)
     
        plap(i,j)=t1 + t2
      ENDDO
      ENDDO
      
        
      DO j=0,n
      DO i=0,m
        t1=(     phi(i-1,j-1) + phi(i-1,j+1) 
     *  - 4.0D+0*phi(i  ,j)
     *        +  phi(i+1,j-1) + phi(i+1,j+1)
     *  +2.0D+0*(phi(i-1,j  ) + phi(i+1,j  )) 
     *  -2.0D+0*(phi(i  ,j-1) + phi(i  ,j+1)))/(4.0D+0*dx*dx)
     
        t2=(     phi(i-1,j-1) + phi(i-1,j+1) 
     *  - 4.0D+0*phi(i  ,j)
     *        +  phi(i+1,j-1) + phi(i+1,j+1)
     *  -2.0D+0*(phi(i-1,j  ) + phi(i+1,j  )) 
     *  +2.0D+0*(phi(i  ,j-1) + phi(i  ,j+1)))/(4.0D+0*dy*dy)
      
        fpe1(i,j)=t1+t2
      ENDDO
      ENDDO
      
C Taking \Delta^2 \phi
      DO j=0,n
      DO i=0,m
        t1=(     plap(i-1,j) 
     *  - 2.0D+0*plap(i  ,j)
     *    +      plap(i+1,j))/(dx*dx)
     
        t2=(     plap(i,j-1) 
     *  - 2.0D+0*plap(i,j  )
     *    +      plap(i,j+1))/(dy*dy)
     
        fpe3(i,j)=t1 + t2
      ENDDO
      ENDDO
      
C Computing the nonlinear term
      DO j=-1,n
      DO i=-1,m
        t1=px(i,j)*px(i,j) + py(i,j)*py(i,j)
        
        fx(i,j)=t1*t1*px(i,j)
        fy(i,j)=t1*t1*py(i,j)
      ENDDO
      ENDDO
       
       
C Computing the force term 
      DO j=0,n-1
      DO i=0,m-1
        t1= (   fx(i  ,j  ) - fx(i-1,j  )
     *         +fx(i  ,j-1) - fx(i-1,j-1))/(2.0D+0*dx)
     
        t2= (   fy(i  ,j  ) - fy(i  ,j-1)
     *         +fy(i-1,j  ) - fy(i-1,j-1))/(2.0D+0*dy)
      
        fpe2(i,j)=t1 + t2
      ENDDO
      ENDDO


      RETURN
      END
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      SUBROUTINE Residue(n,m,sx,sy,x,y,re,nu,eps,aaa,xlen,ylen,
     *           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     *           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,
     *           phi,phi0,px,py,plap,plap1,fx,fy,
     *           ftmp,ftmp1,aux,aux1,aux2,bux,bux1,bux2)
      IMPLICIT NONE

      REAL*8 pi
      PARAMETER(pi=3.14159265358979323846264338327950288D+0)

      INTEGER  n,m,sx,sy,i,j,k,kk
      REAL*8   x(0:sx),y(0:sy),nu,re,eps,aaa
      
      REAL*8 phi(-2:sx+2,-2:sy+2),phi0(0:sx, 0:sy),
     *       px (-1:sx+1,-1:sy+1),py (-1:sx+1,-1:sy+1),
     *       plap(-1:sx+1,-1:sy+1),plap1(0:sx,0:sy),
     *       fx (-1:sx+1,-1:sy+1),fy (-1:sx+1,-1:sy+1),   
     *       ftmp(0:sx, 0:sy),ftmp1(0:sx,0:sy)
     
      INTEGER nts
      REAL*8 final_time,tfinal,cfl,dt
      REAL*8 ctime

      REAL*8 aux(0:sy,0:sx),aux1(0:sy,0:sx),aux2(0:sy,0:sx), 
     *       bux(0:sx,0:sy),bux1(0:sx,0:sy),bux2(0:sx,0:sy)

      REAL*8 WSAVEX(2*sx+15),WSAVEY(2*sy+15),
     *       fmx1(0:sx),fmx2(0:sx),fmy1(0:sy),fmy2(0:sy)


      REAL*8  dx,dy,t1,t2,t3,t4,t5,t6,xlen,ylen
      
      REAL*8  phix,phiy,phixx,phiyy,phixy,
     *        phixxxx,phixxyy,phiyyyy,
     *        aaa1,aaa2,aaa3,aaa4 


C Periodic extension
      DO j=0,n
        phi( -1,j)=phi(m-1,j)
        phi( -2,j)=phi(m-2,j)
        phi(m+1,j)=phi(  1,j)
        phi(m+2,j)=phi(  2,j)
      ENDDO
      
      DO i=-2,m+2
        phi(i, -1)=phi(i,n-1)
        phi(i, -2)=phi(i,n-2)
        phi(i,n+1)=phi(i,  1)
        phi(i,n+2)=phi(i,  2)
      ENDDO
      
C Taking phi_x     
      DO j=-1,n
      DO i=-1,m
        phix = (phi(i+1,j  ) - phi(i,j  )
     *         +phi(i+1,j+1) - phi(i,j+1))/(2.0D+0*dx)
    
        px (i,j)=phix
      ENDDO
      ENDDO
      
      
C Taking phi_y
      DO j=-1,n
      DO i=-1,m
        phiy = (phi(i  ,j+1) - phi(i  ,j)
     *         +phi(i+1,j+1) - phi(i+1,j))/(2.0D+0*dy)
     
        py (i,j)=phiy
      ENDDO
      ENDDO
          
C Update fx, fy
      DO j=-1,n
      DO i=-1,m
        t1=px(i,j)*px(i,j) + py(i,j)*py(i,j)
        
        fx(i,j)=t1*t1*px(i,j)
        fy(i,j)=t1*t1*py(i,j)
      ENDDO
      ENDDO
       
       
C Computing fx_x + fy_y 
      DO j=0,n-1
      DO i=0,m-1
        t1= (   fx(i  ,j  ) - fx(i-1,j  )
     *         +fx(i  ,j-1) - fx(i-1,j-1))/(2.0D+0*dx)
     
        t2= (   fy(i  ,j  ) - fy(i  ,j-1)
     *         +fy(i-1,j  ) - fy(i-1,j-1))/(2.0D+0*dy)
      
        ftmp1(i,j)=-t1 - t2
      ENDDO
      ENDDO
      

C Taking \Delta \phi
      DO j=-1,n+1
      DO i=-1,m+1
        t1=(     phi(i-1,j) 
     *  - 2.0D+0*phi(i  ,j)
     *    +      phi(i+1,j))/(dx*dx)
     
        t2=(     phi(i,j-1) 
     *  - 2.0D+0*phi(i,j  )
     *    +      phi(i,j+1))/(dy*dy)
     
        plap(i,j)=t1 + t2
      ENDDO
      ENDDO
      
      
C Taking \Delta^2 \phi
      DO j=0,n
      DO i=0,m
        t1=(     plap(i-1,j) 
     *  - 2.0D+0*plap(i  ,j)
     *    +      plap(i+1,j))/(dx*dx)
     
        t2=(     plap(i,j-1) 
     *  - 2.0D+0*plap(i,j  )
     *    +      plap(i,j+1))/(dy*dy)
     
        bux(i,j)=t1 + t2
      ENDDO
      ENDDO

      DO j=0,n-1
      DO i=0,m-1
        ftmp1(i,j) = ftmp1(i,j) + eps*eps*bux(i,j)
      ENDDO
      ENDDO
      
      
C The concave diffusion term from the last time step
      DO j=0,n-1
      DO i=0,m-1
        ftmp1(i,j) = ftmp1(i,j) + plap1(i,j)
      ENDDO
      ENDDO
      
C The force term

      DO j=0,n-1
      DO i=0,m-1
        ftmp1(i,j) = ftmp1(i,j) - ftmp(i,j)
      ENDDO
      ENDDO
      
C The time marhing term 

      DO j=0,n-1
      DO i=0,m-1
        ftmp1(i,j) = phi(i,j) - phi0(i,j) + dt*ftmp1(i,j)
      ENDDO
      ENDDO


      RETURN
      END
      
 
      SUBROUTINE Coefficient(n,m,sx,sy,x,y,re,nu,eps,aaa,xlen,ylen,
     *           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     *           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,
     *           phi,phi0,dd,dlap,plap,plap1,px,py,fx,fy,
     *           ftmp,ftmp1,aux,aux1,aux2,bux,bux1,bux2,
     *           cc0,cc1,cc2,cc3,cc4,cc5)
      IMPLICIT NONE

      REAL*8 pi
      PARAMETER(pi=3.14159265358979323846264338327950288D+0)

      INTEGER  n,m,sx,sy,i,j,k,kk
      REAL*8   x(0:sx),y(0:sy),nu,re,eps,aaa
      
      REAL*8 phi(-2:sx+2,-2:sy+2),phi0(0:sx, 0:sy),
     *       px (-1:sx+1,-1:sy+1),py (-1:sx+1,-1:sy+1),
     *       dd (-1:sx+1,-1:sy+1),dlap(0:sx, 0:sy),
     *       plap(-1:sx+1,-1:sy+1),plap1(0:sx,0:sy),
     *       fx (-1:sx+1,-1:sy+1),fy (-1:sx+1,-1:sy+1),  
     *       ftmp(0:sx, 0:sy),ftmp1(0:sx,0:sy)
      
      REAL*8 cc0,cc1,cc2,cc3,cc4,cc5
     
      INTEGER nts
      REAL*8 final_time,tfinal,cfl,dt
      REAL*8 ctime

      REAL*8 aux(0:sy,0:sx),aux1(0:sy,0:sx),aux2(0:sy,0:sx), 
     *       bux(0:sx,0:sy),bux1(0:sx,0:sy),bux2(0:sx,0:sy)

      REAL*8 WSAVEX(2*sx+15),WSAVEY(2*sy+15),
     *       fmx1(0:sx),fmx2(0:sx),fmy1(0:sy),fmy2(0:sy)


      REAL*8  dx,dy,t1,t2,t3,t4,t5,t6,t7,t8,xlen,ylen
      
      REAL*8  phix,phiy,phixx,phiyy,phixy,
     *        phixxxx,phixxyy,phiyyyy,
     *        aaa1,aaa2,aaa3,aaa4
  
  
C Periodic extension
      DO j=0,n
        dd( -1,j)=dd(m-1,j)
        dd(m+1,j)=dd(  1,j)
      ENDDO
      
      DO i=-1,m+1
        dd(i, -1)=dd(i,n-1)
        dd(i,n+1)=dd(i,  1)
      ENDDO
      
C Taking dd_x     
      DO j=-1,n
      DO i=-1,m
        t1  =  (dd(i+1,j  ) - dd(i,j  )
     *         +dd(i+1,j+1) - dd(i,j+1))/(2.0D+0*dx)
    
        fx (i,j)=t1
      ENDDO
      ENDDO
      
      
C Taking dd_y
      DO j=-1,n
      DO i=-1,m
        t1   = (dd(i  ,j+1) - dd(i  ,j)
     *         +dd(i+1,j+1) - dd(i+1,j))/(2.0D+0*dy)
     
        fy (i,j)=t1
      ENDDO
      ENDDO
          
      
C Compute \Delta dd
      DO j=0,n
      DO i=0,m
        t1=(     dd(i-1,j) 
     *  - 2.0D+0*dd(i  ,j)
     *    +      dd(i+1,j))/(dx*dx)
     
        t2=(     dd(i,j-1) 
     *  - 2.0D+0*dd(i,j  )
     *    +      dd(i,j+1))/(dy*dy)
     
        dlap(i,j)=t1 + t2
      ENDDO
      ENDDO
      
      
C Computation of cc5, cc4, part of cc3
      t1=0.0D+0
      t7=0.0D+0
      t8=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=fx(i,j)*fx(i,j) + fy(i,j)*fy(i,j)
        
        t6=t2*t2
        t3=fx(i,j)*px(i,j) + fy(i,j)*py(i,j)
        t4=px(i,j)*px(i,j) + py(i,j)*py(i,j)
     
        t1=t1 + t6*t2
        t7=t7 + t6*t3
        t8=t8 + t6*t4 
      ENDDO
      ENDDO
      cc5=dt*dx*dy*t1
      cc4=5.0D+0*dt*dx*dy*t7
      cc3=2.0D+0*dt*dx*dy*t8
      
      
C Computation of cc3, continued, part of cc2, cc1
      t1=0.0D+0
      t7=0.0D+0
      t8=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=fx(i,j)*px(i,j) + fy(i,j)*py(i,j)
        
        t3=fx(i,j)*fx(i,j) + fy(i,j)*fy(i,j)
        t4=px(i,j)*px(i,j) + py(i,j)*py(i,j)
     
        t6=t2*t2
     
        t1=t1 + t6*t3
        t7=t7 + t6*t2
        t8=t8 + t6*t4 
      ENDDO
      ENDDO
      cc3=cc3 + 8.0D+0*dt*dx*dy*t1
      cc2=4.0D+0*dt*dx*dy*t7
      cc1=4.0D+0*dt*dx*dy*t8
    
            
C Computation of cc2
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=fx(i,j)*fx(i,j) + fy(i,j)*fy(i,j)
        t3=fx(i,j)*px(i,j) + fy(i,j)*py(i,j)
        t4=px(i,j)*px(i,j) + py(i,j)*py(i,j)
        
        t1=t1 + t2*t3*t4 
      ENDDO
      ENDDO
      cc2=cc2 + 6.0D+0*dt*dx*dy*t1
 
      
C Computation of cc1, part of cc0
      t1=0.0D+0
      t7=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=fx(i,j)*fx(i,j) + fy(i,j)*fy(i,j)
        t3=px(i,j)*px(i,j) + py(i,j)*py(i,j)
        t4=px(i,j)*fx(i,j) + py(i,j)*fy(i,j)
        
     
        t1=t1 + t3*t3*t2
        t7=t7 + t3*t3*t4 
      ENDDO
      ENDDO
      cc1=cc1 + dt*dx*dy*t1
      cc0=dt*dx*dy*t7
    
      
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=dlap(i,j)*dlap(i,j) 
        
        t1=t1 + t2
      ENDDO
      ENDDO
      cc1=cc1 + dt*eps*eps*dx*dy*t1
      
c     t1=0.0D+0
c     DO j=0,n-1
c     DO i=0,m-1
c       t2=dd(i,j)*dd(i,j) 
        
c       t1=t1 + t2
c     ENDDO
c     ENDDO
c     cc1=cc1 + dx*dy*t1
      cc1=cc1 + 1.0D+0
      
C Computation of cc0
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t3=phi(i,j) - phi0(i,j)
        
        t1=t1 + t3*dd(i,j)
      ENDDO
      ENDDO
      cc0=cc0 + dx*dy*t1
      
      
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=dlap(i,j)*plap(i,j) 
        
        t1=t1 + t2
      ENDDO
      ENDDO
      cc0=cc0 + dt*eps*eps*dx*dy*t1
      
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=dd(i,j)*plap1(i,j) 
        
        t1=t1 + t2
      ENDDO
      ENDDO
      cc0=cc0 + dt*dx*dy*t1
	 
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=-dd(i,j)*ftmp(i,j) 
        
        t1=t1 + t2
      ENDDO
      ENDDO
      cc0=cc0 + dt*dx*dy*t1


      RETURN
      END 



      SUBROUTINE CHECK(n,m,sx,sy,x,y,re,nu,eps,ctime,dt,
     *           dx,dy,WSAVEX,WSAVEY,
     *           fmx1,fmx2,fmy1,fmy2,phi,phie,eng,enge)
      IMPLICIT NONE

      REAL*8 pi
      PARAMETER(pi=3.14159265358979323846264338327950288D+0)

      INTEGER  n,m,sx,sy,i,j,k,kk
      REAL*8   x(0:sx),y(0:sy),nu,re,eps

      REAL*8 phi (-2:sx+2,-2:sy+2), 
     *       phie(0:sx,0:sy)


      REAL*8 final_time,tfinal,cfl,dt
      REAL*8 ctime
      REAL*8 WSAVEX(2*sx+15),WSAVEY(2*sy+15),
     *       fmx1(0:sx),fmx2(0:sx),fmy1(0:sy),fmy2(0:sy)

      REAL*8  dx,dy,t1,t2,t3,t4,t5,t6,xlen,ylen
      
      REAL*8  eng,enge

C local variables
      REAL*8  aap1,aap2,aap3,aap4,aap5,aap6,aap7,aap8,
     *        a1p,a2p,emaxp

      write(6,*) 'The time is', ctime

      
      a1p=0.0D+0
      a2p=0.0D+0
      emaxp=0.0D+0

      do j=0,n-1
      do i=0,m-1
        aap1=abs(phi(i,j) - phie(i,j)*COS(ctime))

c       a1p=a1p + dx*dy*aap1
        a2p=a2p + aap1*aap1
        
        if(emaxp.le.aap1) emaxp=aap1
      enddo
      enddo

      
      write(6,*) 'The max norm for error for the phase variable'
      write(6,*) emaxp, emaxp/dt
       
c     write(6,*) 'The L1 norm for error for the phase variable'
c     write(6,*) a1p, a1p/dt**2
  
      a2p=sqrt(dx*dy*a2p)
 
      write(6,*) 'The L2 norm for error for the phase variable'
      write(6,*) a2p, a2p/dt
      
C     write(6,*) 'The energy error'
C     write(6,*) eng-enge



      RETURN
      END


   
