      PROGRAM AC_SPFC_Spec_1
      IMPLICIT NONE
      
      INTEGER sx,sy,syp1
      PARAMETER(sx=512,sy=512,syp1=sy+1)
      REAL*8 pi
      PARAMETER(pi=3.14159265358979323846264338327950288D+0)
      
C general variables

      INTEGER  n,m,i,j,kk,kkk,kkkk
      REAL*8   x(0:sx),y(0:sy),nu,re,eps,eps0,aaa



C physical variables (true solution and force terms)  

      REAL*8 phi( 0:sx, 0:sy),phi0(0:sx, 0:sy),
     *       phi1(0:sx  , 0:sy  ),
     *       px ( 0:sx, 0:sy),py ( 0:sx, 0:sy),
     *       dd ( 0:sx, 0:sy),dlap(0:sx, 0:sy),
     *       plap(0:sx, 0:sy),pinv(0:sx, 0:sy),
     *       dinv(0:sx, 0:sy),plap1(0:sx,0:sy),
     *       fx ( 0:sx, 0:sy),fy ( 0:sx, 0:sy),  
     *       ftmp(0:sx, 0:sy),ftmp1(0:sx,0:sy), 
     *       phie(0:sx, 0:sy)

      REAL*8 fpe1(0:sx, 0:sy),fpe2(0:sx, 0:sy),
     *       fpe3(0:sx, 0:sy),
     *       pxe (0:sx, 0:sy),pye (0:sx, 0:sy)
     
      REAL*8 cc0,cc1,cc2,cc3,alpha


      REAL*8  eng,enge


C time variables

      INTEGER nts
      REAL*8 final_time,tfinal,cfl,dt
      REAL*8 ctime
      

C aux matrix variables

      REAL*8 aux(0:sy,0:sx),aux1(0:sy,0:sx),aux2(0:sy,0:sx), 
     *       bux(0:sx,0:sy),bux1(0:sx,0:sy),bux2(0:sx,0:sy)

      REAL*8 WSAVEX(2*sx+15),WSAVEY(2*sy+15),
     *       fmx1(0:sx),fmx2(0:sx),fmy1(0:sy),fmy2(0:sy)

      REAL*8  dx,dy,t1,t2,t3,t4,t5,t6,xlen,ylen
      REAL*8  bphi


      ctime=0.0D+0


      CALL SETUP(n,m,sx,sy,x,y,re,nu,eps,eps0,aaa,xlen,ylen,
     &           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     &           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,     
     &           phi,phi0,phie,px,py,fx,fy,ftmp,ftmp1,
     &           fpe1,fpe2,fpe3,pxe,pye,
     &           aux,aux1,aux2,bux,bux1,bux2,bphi)


C Set up the ghost point guess
      DO j=0,n
      DO i=0,m
        phi1(i,j)=phie(i,j)*COS(-dt)
        plap1(i,j)=fpe1(i,j)
      ENDDO
      ENDDO

      
C Time integration
      DO kk=1,nts
      
         ctime=DBLE(kk-1)*dt
           IF (MOD(kk,5) .EQ. 0) THEN
           WRITE(6,*) 'step :',kk,' time ;',ctime
         END IF
         
C Computing the energy
      t1=0.0D+0
      DO j=1,n
      DO i=0,m-1
        t2=py(i  ,j-1)*py(i  ,j-1)
        t3=py(i+1,j-1)*py(i+1,j-1)
        t4=py(i  ,j  )*py(i  ,j  )
        t5=py(i+1,j  )*py(i+1,j  )
         
        t6=0.25D+0*(t2 + t3 + t4 + t5) 
     *     + px(i,j)*px(i,j) 
     
        t1=t1 + t6*px(i,j)*px(i,j) 
      ENDDO
      ENDDO
       
      DO j=0,n-1
      DO i=1,m
        t2=px(i  ,j+1)*px(i  ,j+1)
        t3=px(i-1,j+1)*px(i-1,j+1)
        t4=px(i  ,j  )*px(i  ,j  )
        t5=px(i-1,j  )*px(i-1,j  )
         
        t6=0.25D+0*(t2 + t3 + t4 + t5) 
     *     + py(i,j)*py(i,j) 
    
        t1=t1 + t6*py(i,j)*py(i,j)
      ENDDO
      ENDDO
      eng=0.25D+0*dx*dy*t1
      
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t5=phi(i,j)
        
        t1=t1 + t5*t5
      ENDDO
      ENDDO
      eng=eng + 0.5D+0*(1.0D+0-eps0)*dx*dy*t1

      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=px(i,j)*px(i,j)
        t3=py(i,j)*py(i,j)
        
        t1=t1 + 0.5D+0 *(t2 + t3)
      ENDDO
      ENDDO
      eng=eng - 2.0D+0*dx*dy*t1


      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t5=plap(i,j)
        
        t1=t1 + t5*t5
      ENDDO
      ENDDO
      eng=eng + 0.5D+0*eps*eps*dx*dy*t1
         
C Initial guess
      DO j=0,n
      DO i=0,m
        phi (i,j)=2.0D+0*phi0(i,j) - phi1(i,j)
      ENDDO
      ENDDO
      
C The force term
      t1= COS(ctime)
      t2= COS(ctime+dt)
      t3= (COS(ctime+dt) - COS(ctime))/dt
      t5=abs(fmx2(1) + fmy2(1))
      t6=1.0D+0 - eps0
      DO j=0,n
      DO i=0,m 
        ftmp(i,j) = 2.0D+0*fpe1(i,j)*t1
     *        + t6*phie(i,j)*t2
     *           -  fpe2(i,j)*t2*t2*t2
     *           +  eps*eps*fpe3(i,j)*t2
     *           + t3*phie(i,j)/t5
      ENDDO
      ENDDO

      
C Iteration loop

      DO kkk=1,15

c        ctime=DBLE(kk-1)*dt
c          IF (MOD(kk,5) .EQ. 0) THEN
c          WRITE(6,*) 'step :',kk,' time ;',ctime
c        END IF


         CALL Residue(n,m,sx,sy,x,y,re,nu,eps,eps0,aaa,xlen,ylen,
     *           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     *           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,
     *           phi,phi0,px,py,plap,plap1,pinv,fx,fy,
     *           ftmp,ftmp1,aux,aux1,aux2,bux,bux1,bux2,bphi)
     

     
C Solve for the search direction: dd 

      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=ftmp1(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (n,m,aux(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        bux(i,j)=aux(j,i)
      ENDDO
      ENDDO

      CALL VRFFTF (m,n,bux(0,0),bux2(0,0),m+1,WSAVEY)

      bux(0,0)=0.0D+0
      t2=0.01D+0
      t5=1.0D+0 - eps0
      DO j=0,n-1
      DO i=0,m-1
        t1=fmx2(i) + fmy2(j)
        if(abs(t1).le.t2) t1=-1.0D+0
        
        t3=-1.0D+0/t1 + dt*eps*eps*t1*t1 - dt*t1 + t5*dt

        bux(i,j)=bux(i,j)/t3
      ENDDO
      ENDDO

      CALL VRFFTB (m,n,bux(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=bux(i,j)
      ENDDO
      ENDDO

      CALL VRFFTB (n,m,aux(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        dd(i,j)=aux(j,i)
      ENDDO
      ENDDO
      
C Normalization in the L^2 norm
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=dd(i,j)*dd(i,j) 
        
        t1=t1 + t2
      ENDDO
      ENDDO
      t1=sqrt(dx*dy*t1) 
      
      DO j=0,n-1
      DO i=0,m-1
        dd(i,j)=dd(i,j)/(t1+1.0D-14) 
      ENDDO
      ENDDO

CCCCCCCCCCC

         CALL Coefficient(n,m,sx,sy,x,y,re,nu,eps,eps0,aaa,xlen,ylen,
     *           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     *           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,
     *           phi,phi0,dd,dlap,plap,pinv,dinv,px,py,fx,fy,
     *           plap1,ftmp,ftmp1,aux,aux1,aux2,bux,bux1,bux2,
     *           cc0,cc1,cc2,cc3,bphi)
     
     
C Newton's iteration loop 
      alpha=0.0D+0
      DO kkkk=1,10
        t1=cc3*alpha*alpha*alpha
     *   + cc2*alpha*alpha
     *   + cc1*alpha
     *   + cc0
     
        t2=3.0D+0*cc3*alpha*alpha
     *   + 2.0D+0*cc2*alpha
     *   +        cc1
     
        alpha=alpha - t1/t2
      ENDDO
CCCCCC

      DO j=0,n-1
      DO i=0,m-1
        phi(i,j)=phi(i,j) + alpha*dd(i,j) 
      ENDDO
      ENDDO
      
      ENDDO
      
      ctime=ctime+dt

      write(6,*) 'the time step kk=', kk

         CALL CHECK(n,m,sx,sy,x,y,re,nu,eps,ctime,dt,
     *           dx,dy,WSAVEX,WSAVEY,
     *           fmx1,fmx2,fmy1,fmy2,phi,phie,eng,enge)
      
      DO j=0,n-1
      DO i=0,m-1
        phi1 (i,j)=phi0 (i,j)
        phi0 (i,j)=phi  (i,j)
        plap1(i,j)=plap(i,j)
      ENDDO
      ENDDO
      
      ENDDO

      STOP
      END
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      SUBROUTINE SETUP(n,m,sx,sy,x,y,re,nu,eps,eps0,aaa,xlen,ylen,
     &           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     &           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,     
     &           phi,phi0,phie,px,py,fx,fy,ftmp,ftmp1,
     &           fpe1,fpe2,fpe3,pxe,pye,
     &           aux,aux1,aux2,bux,bux1,bux2,bphi)
      IMPLICIT NONE

      REAL*8 pi
      PARAMETER(pi=3.14159265358979323846264338327950288D+0)


      INTEGER  n,m,sx,sy,i,j,k,kk
      REAL*8   x(0:sx),y(0:sy),nu,re,eps,eps0,aaa

      REAL*8 phi( 0:sx, 0:sy),phi0(0:sx, 0:sy), 
     *       px ( 0:sx, 0:sy),py ( 0:sx, 0:sy),
     *       fx ( 0:sx, 0:sy),fy ( 0:sx, 0:sy),  
     *       ftmp(0:sx, 0:sy),ftmp1(0:sx,0:sy),
     *       phie(0:sx, 0:sy)

      REAL*8 fpe1(0:sx, 0:sy),fpe2(0:sx, 0:sy),
     *       fpe3(0:sx, 0:sy),
     *       pxe (0:sx, 0:sy),pye (0:sx, 0:sy)

      
      INTEGER nts
      REAL*8 final_time,tfinal,cfl,dt
      REAL*8 ctime
      REAL*8 WSAVEX(2*sx+15),WSAVEY(2*sy+15),
     *       fmx1(0:sx),fmx2(0:sx),fmy1(0:sy),fmy2(0:sy)

      REAL*8 aux(0:sy,0:sx),aux1(0:sy,0:sx),aux2(0:sy,0:sx), 
     *       bux(0:sx,0:sy),bux1(0:sx,0:sy),bux2(0:sx,0:sy)

      REAL*8  dx,dy,t1,t2,t3,t4,t5,t6,xlen,ylen
      REAL*8  bphi

      REAL*8  phix,phiy,phixx,phiyy,phixy,
     *        phixxxx,phixxyy,phiyyyy,
     *        aaa1,aaa2,aaa3,aaa4 


C local variables
      REAL*8  aap1,aap2,aap3,aap4,aap5,aap6,aap7,aap8,
     *        a1p,a2p,emaxp


      m=sx
      n=sy

      Re=1000.0D+0
      nu=1.0D+0/re

      eps=1.0D+0
      eps0=0.025D+0
      aaa=0.5D+0 

C compute Chebyshev differentiation matrices

      xlen=1.0D+0
      ylen=1.0D+0
      dx=xlen/FLOAT(m)
      dy=ylen/FLOAT(n)
   
      DO i=0,m
         x(i)=FLOAT(i)*dx 
      END DO

      DO j=0,n
         y(j)=FLOAT(j)*dy
      END DO



C initialize for FFT
c     CALL VSINQI(m  ,WSAVESQX)
c     CALL VSINQI(n  ,WSAVESQY)
c     CALL VSINQI(nz ,WSAVESQZ)
c     CALL VCOSQI(m  ,WSAVECQX)
c     CALL VCOSQI(n  ,WSAVECQY)
c     CALL VCOSQI(nz ,WSAVECQZ)
c     CALL VSINTI(m-1,WSAVESX )
c     CALL VSINTI(m-1,WSAVESY )
c     CALL VSINTI(nz-1,WSAVESZ)

      CALL VRFFTI(m  ,WSAVEX)
      CALL VRFFTI(n  ,WSAVEY)


      fmx1(0)=0.0D+0
      fmx2(0)=0.0D+0
      DO j=1,m-3,2
        fmx1(j  )=-FLOAT(j+1)*pi/xlen
        fmx1(j+1)=-fmx1(j)
        fmx2(j  )=-FLOAT(j+1)*FLOAT(j+1)*pi*pi/(xlen*xlen)
        fmx2(j+1)= fmx2(j)
      ENDDO
      fmx1(m-1)=-FLOAT(m)*pi/xlen
      fmx2(m-1)=-FLOAT(m)*FLOAT(m)*pi*pi/(xlen*xlen)

      fmy1(0)=0.0D+0
      fmy2(0)=0.0D+0
      DO j=1,n-3,2
        fmy1(j  )=-FLOAT(j+1)*pi/ylen
        fmy1(j+1)=-fmy1(j)
        fmy2(j  )=-FLOAT(j+1)*FLOAT(j+1)*pi*pi/(ylen*ylen)
        fmy2(j+1)= fmy2(j)
      ENDDO
      fmy1(n-1)=-FLOAT(n)*pi/ylen
      fmy2(n-1)=-FLOAT(n)*FLOAT(n)*pi*pi/(ylen*ylen)
      
      
C time stepping 
      cfl=0.5D+0
      dt=cfl*DMIN1(dx,dy)
      dt=0.01D+0
      final_time=1.0D+0
      nts=IDINT(final_time/dt)
      tfinal=DBLE(nts)*dt

      WRITE(6,*) ' '
      WRITE(6,*) 'tfinal, nts, dt :',tfinal,nts,dt
      WRITE(6,*) ' '


C Initial data
      
      DO j=0,n
      DO i=0,m
        phie(i,j) =   1.0D+0/(2.0D+0*pi) 
     *              * SIN(2.0D+0*pi*x(i)    ) 
     *              * COS(2.0D+0*pi*y(j)    )

        phi (i,j)=phie(i,j)

        phix       =  COS(2.0D+0*pi*x(i)    ) 
     *              * COS(2.0D+0*pi*y(j)    )

        phiy       = -SIN(2.0D+0*pi*x(i)    ) 
     *              * SIN(2.0D+0*pi*y(j)    )

        phixx      = -2.0D+0*pi
     *              * SIN(2.0D+0*pi*x(i)    ) 
     *              * COS(2.0D+0*pi*y(j)    )

        phiyy      = -2.0D+0*pi
     *              * SIN(2.0D+0*pi*x(i)    ) 
     *              * COS(2.0D+0*pi*y(j)    )

        phixy      = -2.0D+0*pi
     *              * COS(2.0D+0*pi*x(i)    ) 
     *              * SIN(2.0D+0*pi*y(j)    )

        phixxxx    =  8.0D+0*pi*pi*pi
     *              * SIN(2.0D+0*pi*x(i)    ) 
     *              * COS(2.0D+0*pi*y(j)    )

        phiyyyy    =  8.0D+0*pi*pi*pi
     *              * SIN(2.0D+0*pi*x(i)    ) 
     *              * COS(2.0D+0*pi*y(j)    )

        phixxyy    =  8.0D+0*pi*pi*pi
     *              * SIN(2.0D+0*pi*x(i)    ) 
     *              * COS(2.0D+0*pi*y(j)    )


        t1=phix*phix + phiy*phiy

        fpe1 (i,j)=phixx   + phiyy

        fpe2 (i,j)= t1*( phixx   + phiyy)
     *             +2.0D+0*(phix*phix*phixx 
     *                    + phix*phiy*phixy
     *                    + phix*phiy*phixy
     *                    + phiy*phiy*phiyy)

        fpe3 (i,j)=phixxxx + phiyyyy
     *          + 2.0D+0*phixxyy

        pxe  (i,j)=phix
        pye  (i,j)=phiy

        phi0(i,j)=phie(i,j)
      ENDDO
      ENDDO
      
C Force terms 
      t1= COS(0.0D+0)
      t2= COS(dt)
      t3= (COS(dt) - COS(0.0D+0))/dt
      DO j=0,n
      DO i=0,m 
        ftmp(i,j) = fpe1(i,j)*t1
     *           -  fpe2(i,j)*t2*t2*t2
     *           +  eps*eps*fpe3(i,j)*t2
     *           + t3*phie(i,j)/(8.0D+0*pi*pi)
      ENDDO
      ENDDO
      
C Computing the average
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t1=t1 + phi(i,j) 
      ENDDO
      ENDDO
      bphi=dx*dy*t1/(xlen*ylen)


      RETURN
      END
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      SUBROUTINE Residue(n,m,sx,sy,x,y,re,nu,eps,eps0,aaa,xlen,ylen,
     *           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     *           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,
     *           phi,phi0,px,py,plap,plap1,pinv,fx,fy,
     *           ftmp,ftmp1,aux,aux1,aux2,bux,bux1,bux2,bphi)
      IMPLICIT NONE

      REAL*8 pi
      PARAMETER(pi=3.14159265358979323846264338327950288D+0)

      INTEGER  n,m,sx,sy,i,j,k,kk
      REAL*8   x(0:sx),y(0:sy),nu,re,eps,eps0,aaa
      
      REAL*8 phi( 0:sx, 0:sy),phi0(0:sx, 0:sy),
     *       px ( 0:sx, 0:sy),py ( 0:sx, 0:sy),
     *       plap(0:sx, 0:sy),pinv(0:sx, 0:sy),
     *       plap1(0:sx,0:sy),
     *       fx ( 0:sx, 0:sy),fy ( 0:sx, 0:sy),  
     *       ftmp(0:sx, 0:sy),ftmp1(0:sx,0:sy)
     
      INTEGER nts
      REAL*8 final_time,tfinal,cfl,dt
      REAL*8 ctime

      REAL*8 aux(0:sy,0:sx),aux1(0:sy,0:sx),aux2(0:sy,0:sx), 
     *       bux(0:sx,0:sy),bux1(0:sx,0:sy),bux2(0:sx,0:sy)

      REAL*8 WSAVEX(2*sx+15),WSAVEY(2*sy+15),
     *       fmx1(0:sx),fmx2(0:sx),fmy1(0:sy),fmy2(0:sy)


      REAL*8  dx,dy,t1,t2,t3,t4,t5,t6,xlen,ylen
      REAL*8  bphi
      
      REAL*8  phix,phiy,phixx,phiyy,phixy,
     *        phixxxx,phixxyy,phiyyyy,
     *        aaa1,aaa2,aaa3,aaa4 


 
C Taking phi_x 
      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=phi(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (n,m,aux (0,0),aux2(0,0),n+1,WSAVEX)

      DO i=0,n-1

      aux1(i,0)=0.0D+0
      DO j=1,m-3,2
        aux1(i,j  )= aux(i,j+1)*fmx1(j)

        aux1(i,j+1)= aux(i,j  )*fmx1(j+1)
      ENDDO
      aux1(i,m-1)=0.0D+0
      
      ENDDO

      CALL VRFFTB (n,m,aux1(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        px(i,j)=aux1(j,i)
      ENDDO
      ENDDO
	  

C Taking phi_y 
      DO j=0,n-1
      DO i=0,m-1
        bux(i,j)=phi(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (m,n,bux (0,0),bux2(0,0),m+1,WSAVEY)

      DO i=0,m-1

      bux1(i,0)=0.0D+0
      DO j=1,n-3,2
        bux1(i,j  )= bux(i,j+1)*fmy1(j)

        bux1(i,j+1)= bux(i,j  )*fmy1(j+1)
      ENDDO
      bux1(i,n-1)=0.0D+0
      
      ENDDO

      CALL VRFFTB (m,n,bux1(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        py(i,j)=bux1(i,j)
      ENDDO
      ENDDO
	 

C Update fx, fy 

      DO j=0,n-1
      DO i=0,m-1
	  
	    phix=px(i,j)
	    phiy=py(i,j)
		
	    t1=  px (i,j)*px (i,j) + py (i,j)*py (i,j)

        fx (i,j)= t1*px (i,j) 
	    fy (i,j)= t1*py (i,j)
      ENDDO
      ENDDO

C Taking fx_x 
      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=fx(i,j) 
      ENDDO
      ENDDO
	  

      CALL VRFFTF (n,m,aux (0,0),aux2(0,0),n+1,WSAVEX)

      DO i=0,n-1

      aux1(i,0)=0.0D+0
      DO j=1,m-3,2
        aux1(i,j  )= aux(i,j+1)*fmx1(j)

        aux1(i,j+1)= aux(i,j  )*fmx1(j+1)
      ENDDO
      aux1(i,m-1)=0.0D+0
      
      ENDDO

      CALL VRFFTB (n,m,aux1(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
         ftmp1(i,j)=-aux1(j,i)
      ENDDO
      ENDDO


C Taking fy_y 
      DO j=0,n-1
      DO i=0,m-1
        bux(i,j)=fy(i,j) 
      ENDDO
      ENDDO
	  

      CALL VRFFTF (m,n,bux (0,0),bux2(0,0),m+1,WSAVEY)

      DO i=0,m-1

      bux1(i,0)=0.0D+0
      DO j=1,n-3,2
        bux1(i,j  )= bux(i,j+1)*fmy1(j)

        bux1(i,j+1)= bux(i,j  )*fmy1(j+1)
      ENDDO
      bux1(i,n-1)=0.0D+0
      
      ENDDO

      CALL VRFFTB (m,n,bux1(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        ftmp1(i,j)=ftmp1(i,j) - bux1(i,j)
      ENDDO
      ENDDO
      
C Compute \Delta^2 phi and Delta phi

      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=phi(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (n,m,aux(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        bux(i,j)=aux(j,i)
      ENDDO
      ENDDO

      CALL VRFFTF (m,n,bux(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        t1=fmx2(i) + fmy2(j)

        bux1(i,j)=bux(i,j)*t1
        bux (i,j)=bux(i,j)*t1*t1
      ENDDO
      ENDDO

      CALL VRFFTB (m,n,bux (0,0),bux2(0,0),m+1,WSAVEY)
      CALL VRFFTB (m,n,bux1(0,0),bux2(0,0),m+1,WSAVEY) 

      DO j=0,n-1
      DO i=0,m-1
        aux (j,i)=bux (i,j)
        aux1(j,i)=bux1(i,j)
      ENDDO
      ENDDO

      CALL VRFFTB (n,m,aux (0,0),aux2(0,0),n+1,WSAVEX)
      CALL VRFFTB (n,m,aux1(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        ftmp1(i,j) = ftmp1(i,j) + eps*eps*aux(j,i)
        plap (i,j)= aux1(j,i)
      ENDDO
      ENDDO
    
      
C The lower order diffusion term 
      t5=1.0D+0 - eps0
      DO j=0,n-1
      DO i=0,m-1
        ftmp1(i,j) = ftmp1(i,j) + t5*(phi(i,j) - bphi)
      ENDDO
      ENDDO
      
C The concave diffusion term from the last time step
      DO j=0,n-1
      DO i=0,m-1
        ftmp1(i,j) = ftmp1(i,j) + 2.0D+0*plap1(i,j)
      ENDDO
      ENDDO
      
      
C The force term 

      DO j=0,n-1
      DO i=0,m-1
        ftmp1(i,j) = ftmp1(i,j) - ftmp(i,j)
      ENDDO
      ENDDO
      
C Get (-\Delta_N)^{-1} (\phi - phi0)  

      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=phi(i,j) - phi0(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (n,m,aux(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        bux(i,j)=aux(j,i)
      ENDDO
      ENDDO

      CALL VRFFTF (m,n,bux(0,0),bux2(0,0),m+1,WSAVEY)

      t2=0.01D+0
      bux(0,0)=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t1=-fmx2(i) - fmy2(j)
        if(abs(t1).le.t2) t1=1.0D+0

        bux(i,j)=bux(i,j)/t1
      ENDDO
      ENDDO

      CALL VRFFTB (m,n,bux(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=bux(i,j)
      ENDDO
      ENDDO

      CALL VRFFTB (n,m,aux(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        pinv(i,j)=aux(j,i)
      ENDDO
      ENDDO
      
C The time marhing term 

      DO j=0,n-1
      DO i=0,m-1
        ftmp1(i,j) = pinv(i,j) + dt*ftmp1(i,j)
      ENDDO
      ENDDO


      RETURN
      END
      
 
      SUBROUTINE Coefficient(n,m,sx,sy,x,y,re,nu,eps,eps0,aaa,xlen,ylen,
     *           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     *           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,
     *           phi,phi0,dd,dlap,plap,pinv,dinv,px,py,fx,fy,
     *           plap1,ftmp,ftmp1,aux,aux1,aux2,bux,bux1,bux2,
     *           cc0,cc1,cc2,cc3,bphi)
      IMPLICIT NONE

      REAL*8 pi
      PARAMETER(pi=3.14159265358979323846264338327950288D+0)

      INTEGER  n,m,sx,sy,i,j,k,kk
      REAL*8   x(0:sx),y(0:sy),nu,re,eps,eps0,aaa
      
      REAL*8 phi( 0:sx, 0:sy),phi0(0:sx, 0:sy),
     *       px ( 0:sx, 0:sy),py ( 0:sx, 0:sy),
     *       dd ( 0:sx, 0:sy),dlap(0:sx, 0:sy),
     *       plap(0:sx, 0:sy),pinv(0:sx, 0:sy),
     *       dinv(0:sx, 0:sy),plap1(0:sx,0:sy), 
     *       fx ( 0:sx, 0:sy),fy ( 0:sx, 0:sy),  
     *       ftmp(0:sx, 0:sy),ftmp1(0:sx,0:sy)
      
      REAL*8 cc0,cc1,cc2,cc3
     
      INTEGER nts
      REAL*8 final_time,tfinal,cfl,dt
      REAL*8 ctime

      REAL*8 aux(0:sy,0:sx),aux1(0:sy,0:sx),aux2(0:sy,0:sx), 
     *       bux(0:sx,0:sy),bux1(0:sx,0:sy),bux2(0:sx,0:sy)

      REAL*8 WSAVEX(2*sx+15),WSAVEY(2*sy+15),
     *       fmx1(0:sx),fmx2(0:sx),fmy1(0:sy),fmy2(0:sy)


      REAL*8  dx,dy,t1,t2,t3,t4,t5,t6,xlen,ylen
      REAL*8  bphi
      
      REAL*8  phix,phiy,phixx,phiyy,phixy,
     *        phixxxx,phixxyy,phiyyyy,
     *        aaa1,aaa2,aaa3,aaa4
     
     
C Taking dd_x 
      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=dd(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (n,m,aux (0,0),aux2(0,0),n+1,WSAVEX)

      DO i=0,n-1

      aux1(i,0)=0.0D+0
      DO j=1,m-3,2
        aux1(i,j  )= aux(i,j+1)*fmx1(j) 

        aux1(i,j+1)= aux(i,j  )*fmx1(j+1)
      ENDDO
      aux1(i,m-1)=0.0D+0
      
      ENDDO

      CALL VRFFTB (n,m,aux1(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        fx(i,j)=aux1(j,i)
      ENDDO
      ENDDO

C obtain dd_xx 

      DO i=0,n-1

      aux1(i,0)=0.0D+0
      DO j=1,m-3,2
        aux1(i,j  )= aux(i,j  )*fmx2(j)

        aux1(i,j+1)= aux(i,j+1)*fmx2(j+1)
      ENDDO
      aux1(i,m-1)=0.0D+0

      ENDDO

       
      CALL VRFFTB (n,m,aux1(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        dlap(i,j) = aux1(j,i)
      ENDDO
      ENDDO

C Taking dd_y 
      DO j=0,n-1
      DO i=0,m-1
        bux(i,j)=dd(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (m,n,bux (0,0),bux2(0,0),m+1,WSAVEY)

      DO i=0,m-1

      bux1(i,0)=0.0D+0
      DO j=1,n-3,2
        bux1(i,j  )= bux(i,j+1)*fmy1(j)

        bux1(i,j+1)= bux(i,j  )*fmy1(j+1)
      ENDDO
      bux1(i,n-1)=0.0D+0
      
      ENDDO

      CALL VRFFTB (m,n,bux1(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        fy(i,j)=bux1(i,j)
      ENDDO
      ENDDO

C obtain dd_yy 

      DO i=0,m-1

      bux1(i,0)=0.0D+0
      DO j=1,n-3,2
        bux1(i,j  )= bux(i,j  )*fmy2(j)

        bux1(i,j+1)= bux(i,j+1)*fmy2(j+1)
      ENDDO
      bux1(i,n-1)=0.0D+0

      ENDDO

       
      CALL VRFFTB (m,n,bux1(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        dlap(i,j) = dlap(i,j) + bux1(i,j)
      ENDDO
      ENDDO
      
C Compute (-\Delta_N)^{-1} dd  

      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=dd(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (n,m,aux(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        bux(i,j)=aux(j,i)
      ENDDO
      ENDDO

      CALL VRFFTF (m,n,bux(0,0),bux2(0,0),m+1,WSAVEY)

      t2=0.01D+0
      bux(0,0)=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t1=-fmx2(i) - fmy2(j)
        if(abs(t1).le.t2) t1=1.0D+0

        bux(i,j)=bux(i,j)/t1
      ENDDO
      ENDDO

      CALL VRFFTB (m,n,bux(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=bux(i,j)
      ENDDO
      ENDDO

      CALL VRFFTB (n,m,aux(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        dinv(i,j)=aux(j,i)
      ENDDO
      ENDDO
      
C Taking dinv_x 
      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=dinv(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (n,m,aux (0,0),aux2(0,0),n+1,WSAVEX)

      DO i=0,n-1

      aux1(i,0)=0.0D+0
      DO j=1,m-3,2
        aux1(i,j  )= aux(i,j+1)*fmx1(j)

        aux1(i,j+1)= aux(i,j  )*fmx1(j+1)
      ENDDO
      aux1(i,m-1)=0.0D+0
      
      ENDDO

      CALL VRFFTB (n,m,aux1(0,0),aux2(0,0),n+1,WSAVEX)
	  

C Taking dinv_y 
      DO j=0,n-1
      DO i=0,m-1
        bux(i,j)=dinv(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (m,n,bux (0,0),bux2(0,0),m+1,WSAVEY)

      DO i=0,m-1

      bux1(i,0)=0.0D+0
      DO j=1,n-3,2
        bux1(i,j  )= bux(i,j+1)*fmy1(j)

        bux1(i,j+1)= bux(i,j  )*fmy1(j+1)
      ENDDO
      bux1(i,n-1)=0.0D+0
      
      ENDDO

      CALL VRFFTB (m,n,bux1(0,0),bux2(0,0),m+1,WSAVEY)

      
C Computation of cc3
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=fx(i,j)*fx(i,j) + fy(i,j)*fy(i,j)
        
        t1=t1 + t2*t2
      ENDDO
      ENDDO
      cc3=dt*dx*dy*t1
      
C Computation of cc2
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=fx(i,j)*fx(i,j) + fy(i,j)*fy(i,j)
        t3=fx(i,j)*px(i,j) + fy(i,j)*py(i,j)
        
        t1=t1 + t2*t3
      ENDDO
      ENDDO
      cc2=3.0D+0*dt*dx*dy*t1
      
C Computation of cc1
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t3=fx(i,j)*px(i,j) + fy(i,j)*py(i,j)
        
        t1=t1 + t3*t3
      ENDDO
      ENDDO
      cc1=2.0D+0*dt*dx*dy*t1
      
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=fx(i,j)*fx(i,j) + fy(i,j)*fy(i,j)
        t3=px(i,j)*px(i,j) + py(i,j)*py(i,j)
        
        t1=t1 + t2*t3
      ENDDO
      ENDDO
      cc1=cc1 + dt*dx*dy*t1
      
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=dlap(i,j)*dlap(i,j) 
        
        t1=t1 + t2
      ENDDO
      ENDDO
      cc1=cc1 + dt*eps*eps*dx*dy*t1
      
      t1=0.0D+0
      t5=1.0D+0 - eps0
C     DO j=0,n-1
C     DO i=0,m-1
C       t2=dd(i,j)*dd(i,j) 
        
C       t1=t1 + t2
C     ENDDO
C     ENDDO
C     cc1=cc1 + t5*dt*dx*dy*t1
      cc1=cc1 + t5*dt*1.0D+0
      
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=aux1(j,i)*aux1(j,i) + bux1(i,j)*bux1(i,j) 
        
        t1=t1 + t2
      ENDDO
      ENDDO
      cc1=cc1 + dx*dy*t1
      
C Computation of cc0
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t3=pinv(i,j)
        
        t1=t1 + t3*dd(i,j)
      ENDDO
      ENDDO
      cc0=dx*dy*t1
      
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=px(i,j)*px(i,j) + py(i,j)*py(i,j)
        t3=px(i,j)*fx(i,j) + py(i,j)*fy(i,j)
        
        t1=t1 + t2*t3
      ENDDO
      ENDDO
      cc0=cc0 + dt*dx*dy*t1
      
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=dlap(i,j)*plap(i,j) 
        
        t1=t1 + t2
      ENDDO
      ENDDO
      cc0=cc0 + dt*eps*eps*dx*dy*t1
      
      t1=0.0D+0
      t5=1.0D+0 - eps0
      DO j=0,n-1
      DO i=0,m-1
        t2=phi(i,j)*dd(i,j) 
        
        t1=t1 + t2
      ENDDO
      ENDDO
      cc0=cc0 + t5*dt*dx*dy*t1
      
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=dd(i,j)*plap1(i,j) 
        
        t1=t1 + t2
      ENDDO
      ENDDO
      cc0=cc0 + 2.0D+0*dt*dx*dy*t1
	 
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=-dd(i,j)*ftmp(i,j) 
        
        t1=t1 + t2
      ENDDO
      ENDDO
      cc0=cc0 + dt*dx*dy*t1


      RETURN
      END 



      SUBROUTINE CHECK(n,m,sx,sy,x,y,re,nu,eps,ctime,dt,
     *           dx,dy,WSAVEX,WSAVEY,
     *           fmx1,fmx2,fmy1,fmy2,phi,phie,eng,enge)
      IMPLICIT NONE

      REAL*8 pi
      PARAMETER(pi=3.14159265358979323846264338327950288D+0)

      INTEGER  n,m,sx,sy,i,j,k,kk
      REAL*8   x(0:sx),y(0:sy),nu,re,eps

      REAL*8 phi (0:sx,0:sy), 
     *       phie(0:sx,0:sy)


      REAL*8 final_time,tfinal,cfl,dt
      REAL*8 ctime
      REAL*8 WSAVEX(2*sx+15),WSAVEY(2*sy+15),
     *       fmx1(0:sx),fmx2(0:sx),fmy1(0:sy),fmy2(0:sy)

      REAL*8  dx,dy,t1,t2,t3,t4,t5,t6,xlen,ylen
      
      REAL*8  eng,enge

C local variables
      REAL*8  aap1,aap2,aap3,aap4,aap5,aap6,aap7,aap8,
     *        a1p,a2p,emaxp

      write(6,*) 'The time is', ctime

      
      a1p=0.0D+0
      a2p=0.0D+0
      emaxp=0.0D+0

      do j=0,n-1
      do i=0,m-1
        aap1=abs(phi(i,j) - phie(i,j)*COS(ctime))

c       a1p=a1p + dx*dy*aap1
        a2p=a2p + aap1*aap1
        
        if(emaxp.le.aap1) emaxp=aap1
      enddo
      enddo

      
      write(6,*) 'The max norm for error for the phase variable'
      write(6,*) emaxp, emaxp/dt**2
       
c     write(6,*) 'The L1 norm for error for the phase variable'
c     write(6,*) a1p, a1p/dt**2
  
      a2p=sqrt(dx*dy*a2p)
 
      write(6,*) 'The L2 norm for error for the phase variable'
      write(6,*) a2p, a2p/dt**2
      
C     write(6,*) 'The energy error'
C     write(6,*) eng-enge



      RETURN
      END


   
