      PROGRAM rMBE_P6_Spec_1
      IMPLICIT NONE
      
      INTEGER sx,sy,syp1
      PARAMETER(sx=384,sy=384,syp1=sy+1)
      REAL*8 pi
      PARAMETER(pi=3.14159265358979323846264338327950288D+0)
      
C general variables

      INTEGER  n,m,i,j,kk,kkk,kkkk
      REAL*8   x(0:sx),y(0:sy),nu,re,eps,aaa



C physical variables (true solution and force terms)  

      REAL*8 phi( 0:sx, 0:sy),phi0(0:sx, 0:sy),
     *       phi1(0:sx  , 0:sy  ),
     *       px ( 0:sx, 0:sy),py ( 0:sx, 0:sy),
     *       dd ( 0:sx, 0:sy),dlap(0:sx, 0:sy),
     *       plap(0:sx, 0:sy),plap1(0:sx,0:sy), 
     *       fx ( 0:sx, 0:sy),fy ( 0:sx, 0:sy),  
     *       ftmp1(0:sx,0:sy)
    
      REAL*8 cc0,cc1,cc2,cc3,cc4,cc5,alpha


      REAL*8  eng,enge,bphi


C time variables

      INTEGER nts
      REAL*8 final_time,tfinal,cfl,dt
      REAL*8 ctime
      

C aux matrix variables

      REAL*8 aux(0:sy,0:sx),aux1(0:sy,0:sx),aux2(0:sy,0:sx), 
     *       bux(0:sx,0:sy),bux1(0:sx,0:sy),bux2(0:sx,0:sy)

      REAL*8 WSAVEX(2*sx+15),WSAVEY(2*sy+15),
     *       fmx1(0:sx),fmx2(0:sx),fmy1(0:sy),fmy2(0:sy)
     
      REAL*8  rpsi((sx+1)*(sy+1)),
     *        reng(400000+1)

      REAL*8  dx,dy,t1,t2,t3,t4,t5,t6,xlen,ylen
      
      INTEGER lenwrec,len,nmd,ndv,ipos,isign
      


      CALL SETUP(n,m,sx,sy,x,y,re,nu,eps,aaa,xlen,ylen,
     &           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     &           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,     
     &           phi,phi0,px,py,fx,fy,plap,ftmp1,
     &           aux,aux1,aux2,bux,bux1,bux2,rpsi,bphi)
     
      ctime=400.0D+0


C Set up the ghost point guess
      DO j=0,n-1
      DO i=0,m-1
        phi1(i,j)=phi(i,j)
        plap1(i,j)=plap(i,j)
      ENDDO
      ENDDO
      

C Time integration
      DO kk=1,nts
      
         ctime=400.0D+0 + DBLE(kk-1)*dt
           IF (MOD(kk,5) .EQ. 0) THEN
           WRITE(6,*) 'step :',kk,' time ;',ctime
         END IF
         
C Computing the energy
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=px(i,j)*px(i,j) + py(i,j)*py(i,j)
        
        t1=t1 + t2*t2*t2 
      ENDDO
      ENDDO
      eng=dx*dy*t1/6.0D+0

      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=px(i,j)*px(i,j) + py(i,j)*py(i,j)
        
        t1=t1 + t2 
      ENDDO
      ENDDO
      eng=eng - 0.5D+0*dx*dy*t1


      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t5=plap(i,j)
        
        t1=t1 + t5*t5
      ENDDO
      ENDDO
      eng=eng + 0.5D+0*eps*eps*dx*dy*t1
      
      write(6,*) 'the time step kk=', kk, 'enegy:', eng
      
      reng(kk)=eng
         
C Initial guess
      DO j=0,n-1
      DO i=0,m-1
        phi (i,j)=2.0D+0*phi0(i,j) - phi1(i,j)
      ENDDO
      ENDDO
      

C Iteration loop

      DO kkk=1,10

         CALL Residue(n,m,sx,sy,x,y,re,nu,eps,aaa,xlen,ylen,
     *           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     *           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,
     *           phi,phi0,px,py,plap,plap1,fx,fy,ftmp1,
     *           aux,aux1,aux2,bux,bux1,bux2,bphi)
     
     
C Solve for the search direction: dd 

      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=ftmp1(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (n,m,aux(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        bux(i,j)=aux(j,i)
      ENDDO
      ENDDO

      CALL VRFFTF (m,n,bux(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        t1=fmx2(i) + fmy2(j)
        t3=1.0D+0 + dt*eps*eps*t1*t1 - dt*t1

        bux(i,j)=bux(i,j)/t3
      ENDDO
      ENDDO

      CALL VRFFTB (m,n,bux(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=bux(i,j)
      ENDDO
      ENDDO

      CALL VRFFTB (n,m,aux(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        dd(i,j)=aux(j,i)
      ENDDO
      ENDDO
      
C Normalization in the L^2 norm
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=dd(i,j)*dd(i,j) 
        
        t1=t1 + t2
      ENDDO
      ENDDO
      t1=sqrt(dx*dy*t1) 
      
      DO j=0,n-1
      DO i=0,m-1
        dd(i,j)=dd(i,j)/(t1+1.0D-14) 
      ENDDO
      ENDDO

CCCCCCCCCCC

         CALL Coefficient(n,m,sx,sy,x,y,re,nu,eps,aaa,xlen,ylen,
     *           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     *           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,
     *           phi,phi0,dd,dlap,plap,plap1,px,py,fx,fy,
     *           ftmp1,aux,aux1,aux2,bux,bux1,bux2,
     *           cc0,cc1,cc2,cc3,cc4,cc5,bphi)
     
     
C Newton's iteration loop 
      alpha=0.0D+0
      DO kkkk=1,10
        t1=cc5*alpha*alpha*alpha*alpha*alpha
     *   + cc4*alpha*alpha*alpha*alpha
     *   + cc3*alpha*alpha*alpha
     *   + cc2*alpha*alpha
     *   + cc1*alpha
     *   + cc0
     
        t2=5.0D+0*cc5*alpha*alpha*alpha*alpha
     *   + 4.0D+0*cc4*alpha*alpha*alpha
     *   + 3.0D+0*cc3*alpha*alpha
     *   + 2.0D+0*cc2*alpha
     *   +        cc1
     
        alpha=alpha - t1/t2
      ENDDO
CCCCCC

      DO j=0,n-1
      DO i=0,m-1
        phi(i,j)=phi(i,j) + alpha*dd(i,j) 
      ENDDO
      ENDDO
      
      END DO
      
      ctime=ctime+dt
      
      
C     write(6,*) 'the time step kk=', kk

      
      DO j=0,n-1
      DO i=0,m-1
        phi1 (i,j)=phi0 (i,j)
        phi0 (i,j)=phi  (i,j)
        plap1(i,j)=plap(i,j)
      ENDDO
      ENDDO
      
      ENDDO
      
      lenwrec=100
      len=(m+1)*(n+1)
      nmd=MOD(len,lenwrec)
      ndv=(len-nmd)/lenwrec

      ipos=1
         DO i=0,m
           DO j=0,n
             rpsi(ipos)=phi(i  ,j)
             ipos=ipos+1
           ENDDO
         END DO

      WRITE(6,*) 'WRITING phi.dat '  
      WRITE(10,*) 'WRITING phi.dat '  
      OPEN(unit=50,file='phi.dat',access='direct',
     *     form='unformatted',recl=8*lenwrec,status='unknown')
      ipos=1
      DO j=1,ndv
         WRITE(50,rec=j) (rpsi(ipos+i-1),i=1,lenwrec)
         ipos=ipos+lenwrec
      END DO
      WRITE(50,rec=ndv+1) (rpsi(ipos+i-1),i=1,nmd)
      CLOSE(unit=50) 
      
C Computing the energy
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=px(i,j)*px(i,j) + py(i,j)*py(i,j)
        
        t1=t1 + t2*t2*t2 
      ENDDO
      ENDDO
      eng=dx*dy*t1/6.0D+0

      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=px(i,j)*px(i,j) + py(i,j)*py(i,j)
        
        t1=t1 + t2 
      ENDDO
      ENDDO
      eng=eng - 0.5D+0*dx*dy*t1


      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t5=plap(i,j)
        
        t1=t1 + t5*t5
      ENDDO
      ENDDO
      eng=eng + 0.5D+0*eps*eps*dx*dy*t1
      
      reng(nts+1)=eng
      
      lenwrec=100
      len=nts+1
      nmd=MOD(len,lenwrec)
      ndv=(len-nmd)/lenwrec

      WRITE(6,*) 'WRITING eng.dat '  
      WRITE(10,*) 'WRITING eng.dat '  
      OPEN(unit=50,file='eng.dat',access='direct',
     *     form='unformatted',recl=8*lenwrec,status='unknown')
      ipos=1
      DO j=1,ndv
         WRITE(50,rec=j) (reng(ipos+i-1),i=1,lenwrec)
         ipos=ipos+lenwrec
      END DO
      WRITE(50,rec=ndv+1) (reng(ipos+i-1),i=1,nmd)
      CLOSE(unit=50) 


      STOP
      END
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      SUBROUTINE SETUP(n,m,sx,sy,x,y,re,nu,eps,aaa,xlen,ylen,
     &           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     &           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,     
     &           phi,phi0,px,py,fx,fy,plap,ftmp1,
     &           aux,aux1,aux2,bux,bux1,bux2,rpsi,bphi)
      IMPLICIT NONE

      REAL*8 pi
      PARAMETER(pi=3.14159265358979323846264338327950288D+0)


      INTEGER  n,m,sx,sy,i,j,k,kk
      REAL*8   x(0:sx),y(0:sy),nu,re,eps,aaa

      REAL*8 phi( 0:sx, 0:sy),phi0(0:sx, 0:sy), 
     *       px ( 0:sx, 0:sy),py ( 0:sx, 0:sy),
     *       plap(0:sx, 0:sy), 
     *       fx ( 0:sx, 0:sy),fy ( 0:sx, 0:sy),  
     *       ftmp1(0:sx,0:sy)

      
      INTEGER nts
      REAL*8 final_time,tfinal,cfl,dt
      REAL*8 ctime
      REAL*8 WSAVEX(2*sx+15),WSAVEY(2*sy+15),
     *       fmx1(0:sx),fmx2(0:sx),fmy1(0:sy),fmy2(0:sy)

      REAL*8 aux(0:sy,0:sx),aux1(0:sy,0:sx),aux2(0:sy,0:sx), 
     *       bux(0:sx,0:sy),bux1(0:sx,0:sy),bux2(0:sx,0:sy)

      REAL*8  dx,dy,t1,t2,t3,t4,t5,t6,xlen,ylen
      REAL*8  bphi

      REAL*8  phix,phiy,phixx,phiyy,phixy,
     *        phixxxx,phixxyy,phiyyyy,
     *        aaa1,aaa2,aaa3,aaa4
     
      REAL*8  rpsi((sx+1)*(sy+1)) 


C local variables
      REAL*8  aap1,aap2,aap3,aap4,aap5,aap6,aap7,aap8,
     *        a1p,a2p,emaxp
      REAL*8  aaarandom


      m=sx
      n=sy

      Re=1000.0D+0
      nu=1.0D+0/re

      eps=0.03D+0
      aaa=0.5D+0 

C compute Chebyshev differentiation matrices

      xlen=12.8D+0
      ylen=12.8D+0
      dx=xlen/FLOAT(m)
      dy=ylen/FLOAT(n)
   
      DO i=0,m
         x(i)=FLOAT(i)*dx 
      END DO

      DO j=0,n
         y(j)=FLOAT(j)*dy
      END DO



C initialize for FFT
c     CALL VSINQI(m  ,WSAVESQX)
c     CALL VSINQI(n  ,WSAVESQY)
c     CALL VSINQI(nz ,WSAVESQZ)
c     CALL VCOSQI(m  ,WSAVECQX)
c     CALL VCOSQI(n  ,WSAVECQY)
c     CALL VCOSQI(nz ,WSAVECQZ)
c     CALL VSINTI(m-1,WSAVESX )
c     CALL VSINTI(m-1,WSAVESY )
c     CALL VSINTI(nz-1,WSAVESZ)

      CALL VRFFTI(m  ,WSAVEX)
      CALL VRFFTI(n  ,WSAVEY)


      fmx1(0)=0.0D+0
      fmx2(0)=0.0D+0
      DO j=1,m-3,2
        fmx1(j  )=-FLOAT(j+1)*pi/xlen
        fmx1(j+1)=-fmx1(j)
        fmx2(j  )=-FLOAT(j+1)*FLOAT(j+1)*pi*pi/(xlen*xlen)
        fmx2(j+1)= fmx2(j)
      ENDDO
      fmx1(m-1)=-FLOAT(m)*pi/xlen
      fmx2(m-1)=-FLOAT(m)*FLOAT(m)*pi*pi/(xlen*xlen)

      fmy1(0)=0.0D+0
      fmy2(0)=0.0D+0
      DO j=1,n-3,2
        fmy1(j  )=-FLOAT(j+1)*pi/ylen
        fmy1(j+1)=-fmy1(j)
        fmy2(j  )=-FLOAT(j+1)*FLOAT(j+1)*pi*pi/(ylen*ylen)
        fmy2(j+1)= fmy2(j)
      ENDDO
      fmy1(n-1)=-FLOAT(n)*pi/ylen
      fmy2(n-1)=-FLOAT(n)*FLOAT(n)*pi*pi/(ylen*ylen)
      
      
C time stepping 
      cfl=0.5D+0
      dt=cfl*DMIN1(dx,dy)
      dt=0.04D+0
      final_time=5600.0D+0
      nts=IDINT(final_time/dt)
      tfinal=DBLE(nts)*dt

      WRITE(6,*) ' '
      WRITE(6,*) 'tfinal, nts, dt :',tfinal,nts,dt
      WRITE(6,*) ' '
      
      
c Read the data
c read phi
      lenwsrec=100
      len=(m +1)*(n +1)
      nmd=MOD(len,lenwsrec)
      ndv=(len-nmd)/lenwsrec      
      WRITE(6,*) 'READING phi400.dat '
      OPEN(unit=50,file='phi400.dat',access='direct',
     *     form='unformatted',recl=8*lenwsrec,status='old')
      ipos=1
      DO j=1,ndv
         READ(50,rec=j) (rpsi(ipos+i-1),i=1,lenwsrec)
         ipos=ipos+lenwsrec
      END DO
      READ(50,rec=ndv+1) (rpsi(ipos+i-1),i=1,nmd)
      CLOSE(unit=50)

      ipos=1
      do i=0,m 
      do j=0,n 
        phi(i,j)=rpsi(ipos)
        ipos=ipos+1
        
        phi0(i,j)=phi (i,j)
      enddo
      enddo

	  
      bphi=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        bphi=bphi + phi(i,j)
      ENDDO
      ENDDO
      bphi=bphi/(FLOAT(m)*FLOAT(n))
      
    
C Taking phi_x 
      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=phi(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (n,m,aux (0,0),aux2(0,0),n+1,WSAVEX)

      DO i=0,n-1

      aux1(i,0)=0.0D+0
      DO j=1,m-3,2
        aux1(i,j  )= aux(i,j+1)*fmx1(j)

        aux1(i,j+1)= aux(i,j  )*fmx1(j+1)
      ENDDO
      aux1(i,m-1)=0.0D+0
      
      ENDDO

      CALL VRFFTB (n,m,aux1(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        px(i,j)=aux1(j,i)
      ENDDO
      ENDDO
      
C obtain phi_xx 

      DO i=0,n-1

      aux1(i,0)=0.0D+0
      DO j=1,m-3,2
        aux1(i,j  )= aux(i,j  )*fmx2(j)

        aux1(i,j+1)= aux(i,j+1)*fmx2(j+1)
      ENDDO
      aux1(i,m-1)=0.0D+0

      ENDDO

       
      CALL VRFFTB (n,m,aux1(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        plap(i,j) = aux1(j,i)
      ENDDO
      ENDDO
	  

C Taking phi_y 
      DO j=0,n-1
      DO i=0,m-1
        bux(i,j)=phi(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (m,n,bux (0,0),bux2(0,0),m+1,WSAVEY)

      DO i=0,m-1

      bux1(i,0)=0.0D+0
      DO j=1,n-3,2
        bux1(i,j  )= bux(i,j+1)*fmy1(j)

        bux1(i,j+1)= bux(i,j  )*fmy1(j+1)
      ENDDO
      bux1(i,n-1)=0.0D+0
      
      ENDDO

      CALL VRFFTB (m,n,bux1(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        py(i,j)=bux1(i,j)
      ENDDO
      ENDDO
      
C obtain phi_yy 

      DO i=0,m-1

      bux1(i,0)=0.0D+0
      DO j=1,n-3,2
        bux1(i,j  )= bux(i,j  )*fmy2(j)

        bux1(i,j+1)= bux(i,j+1)*fmy2(j+1)
      ENDDO
      bux1(i,n-1)=0.0D+0

      ENDDO

       
      CALL VRFFTB (m,n,bux1(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        plap(i,j) = plap(i,j) + bux1(i,j)
      ENDDO
      ENDDO


      RETURN
      END
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      SUBROUTINE Residue(n,m,sx,sy,x,y,re,nu,eps,aaa,xlen,ylen,
     *           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     *           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,
     *           phi,phi0,px,py,plap,plap1,fx,fy,ftmp1,
     *           aux,aux1,aux2,bux,bux1,bux2,bphi)
      IMPLICIT NONE

      REAL*8 pi
      PARAMETER(pi=3.14159265358979323846264338327950288D+0)

      INTEGER  n,m,sx,sy,i,j,k,kk
      REAL*8   x(0:sx),y(0:sy),nu,re,eps,aaa
      
      REAL*8 phi( 0:sx, 0:sy),phi0(0:sx, 0:sy),
     *       px ( 0:sx, 0:sy),py ( 0:sx, 0:sy),
     *       plap(0:sx, 0:sy),plap1(0:sx,0:sy),
     *       fx ( 0:sx, 0:sy),fy ( 0:sx, 0:sy),  
     *       ftmp1(0:sx,0:sy)
     
      INTEGER nts
      REAL*8 final_time,tfinal,cfl,dt
      REAL*8 ctime

      REAL*8 aux(0:sy,0:sx),aux1(0:sy,0:sx),aux2(0:sy,0:sx), 
     *       bux(0:sx,0:sy),bux1(0:sx,0:sy),bux2(0:sx,0:sy)

      REAL*8 WSAVEX(2*sx+15),WSAVEY(2*sy+15),
     *       fmx1(0:sx),fmx2(0:sx),fmy1(0:sy),fmy2(0:sy)


      REAL*8  dx,dy,t1,t2,t3,t4,t5,t6,xlen,ylen
      REAL*8  bphi
      
      REAL*8  phix,phiy,phixx,phiyy,phixy,
     *        phixxxx,phixxyy,phiyyyy,
     *        aaa1,aaa2,aaa3,aaa4 


 
C Taking phi_x 
      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=phi(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (n,m,aux (0,0),aux2(0,0),n+1,WSAVEX)

      DO i=0,n-1

      aux1(i,0)=0.0D+0
      DO j=1,m-3,2
        aux1(i,j  )= aux(i,j+1)*fmx1(j)

        aux1(i,j+1)= aux(i,j  )*fmx1(j+1)
      ENDDO
      aux1(i,m-1)=0.0D+0
      
      ENDDO

      CALL VRFFTB (n,m,aux1(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        px(i,j)=aux1(j,i)
      ENDDO
      ENDDO
	  

C Taking phi_y 
      DO j=0,n-1
      DO i=0,m-1
        bux(i,j)=phi(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (m,n,bux (0,0),bux2(0,0),m+1,WSAVEY)

      DO i=0,m-1

      bux1(i,0)=0.0D+0
      DO j=1,n-3,2
        bux1(i,j  )= bux(i,j+1)*fmy1(j)

        bux1(i,j+1)= bux(i,j  )*fmy1(j+1)
      ENDDO
      bux1(i,n-1)=0.0D+0
      
      ENDDO

      CALL VRFFTB (m,n,bux1(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        py(i,j)=bux1(i,j)
      ENDDO
      ENDDO
	 

C Update fx, fy 

      DO j=0,n-1
      DO i=0,m-1
	  
	    phix=px(i,j)
	    phiy=py(i,j)
		
	    t1=  px (i,j)*px (i,j) + py (i,j)*py (i,j)

        fx (i,j)= t1*t1*px (i,j) 
	    fy (i,j)= t1*t1*py (i,j)
      ENDDO
      ENDDO

C Taking fx_x 
      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=fx(i,j) 
      ENDDO
      ENDDO
	  

      CALL VRFFTF (n,m,aux (0,0),aux2(0,0),n+1,WSAVEX)

      DO i=0,n-1

      aux1(i,0)=0.0D+0
      DO j=1,m-3,2
        aux1(i,j  )= aux(i,j+1)*fmx1(j)

        aux1(i,j+1)= aux(i,j  )*fmx1(j+1)
      ENDDO
      aux1(i,m-1)=0.0D+0
      
      ENDDO

      CALL VRFFTB (n,m,aux1(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
         ftmp1(i,j)=-aux1(j,i)
      ENDDO
      ENDDO


C Taking fy_y 
      DO j=0,n-1
      DO i=0,m-1
        bux(i,j)=fy(i,j) 
      ENDDO
      ENDDO
	  

      CALL VRFFTF (m,n,bux (0,0),bux2(0,0),m+1,WSAVEY)

      DO i=0,m-1

      bux1(i,0)=0.0D+0
      DO j=1,n-3,2
        bux1(i,j  )= bux(i,j+1)*fmy1(j)

        bux1(i,j+1)= bux(i,j  )*fmy1(j+1)
      ENDDO
      bux1(i,n-1)=0.0D+0
      
      ENDDO

      CALL VRFFTB (m,n,bux1(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        ftmp1(i,j)=ftmp1(i,j) - bux1(i,j)
      ENDDO
      ENDDO
      
C Compute \Delta^2 phi and Delta phi

      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=phi(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (n,m,aux(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        bux(i,j)=aux(j,i)
      ENDDO
      ENDDO

      CALL VRFFTF (m,n,bux(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        t1=fmx2(i) + fmy2(j)

        bux1(i,j)=bux(i,j)*t1
        bux (i,j)=bux(i,j)*t1*t1
      ENDDO
      ENDDO

      CALL VRFFTB (m,n,bux (0,0),bux2(0,0),m+1,WSAVEY)
      CALL VRFFTB (m,n,bux1(0,0),bux2(0,0),m+1,WSAVEY) 

      DO j=0,n-1
      DO i=0,m-1
        aux (j,i)=bux (i,j)
        aux1(j,i)=bux1(i,j)
      ENDDO
      ENDDO

      CALL VRFFTB (n,m,aux (0,0),aux2(0,0),n+1,WSAVEX)
      CALL VRFFTB (n,m,aux1(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        ftmp1(i,j) = ftmp1(i,j) + eps*eps*aux(j,i)
        plap (i,j)= aux1(j,i)
      ENDDO
      ENDDO

C The concave diffusion term from the last time step
      DO j=0,n-1
      DO i=0,m-1
        ftmp1(i,j) = ftmp1(i,j) + plap1(i,j)
      ENDDO
      ENDDO
      
C The time marhing term 

      DO j=0,n-1
      DO i=0,m-1
        ftmp1(i,j) = phi(i,j) - phi0(i,j) + dt*ftmp1(i,j)
      ENDDO
      ENDDO


      RETURN
      END
      
 
      SUBROUTINE Coefficient(n,m,sx,sy,x,y,re,nu,eps,aaa,xlen,ylen,
     *           final_time,tfinal,ctime,cfl,dx,dy,dt,nts,
     *           WSAVEX,WSAVEY,fmx1,fmx2,fmy1,fmy2,
     *           phi,phi0,dd,dlap,plap,plap1,px,py,fx,fy,
     *           ftmp1,aux,aux1,aux2,bux,bux1,bux2,
     *           cc0,cc1,cc2,cc3,cc4,cc5,bphi)
      IMPLICIT NONE

      REAL*8 pi
      PARAMETER(pi=3.14159265358979323846264338327950288D+0)

      INTEGER  n,m,sx,sy,i,j,k,kk
      REAL*8   x(0:sx),y(0:sy),nu,re,eps,aaa
      
      REAL*8 phi( 0:sx, 0:sy),phi0(0:sx, 0:sy),
     *       px ( 0:sx, 0:sy),py ( 0:sx, 0:sy),
     *       dd ( 0:sx, 0:sy),dlap(0:sx, 0:sy),
     *       plap(0:sx, 0:sy),plap1(0:sx,0:sy), 
     *       fx ( 0:sx, 0:sy),fy ( 0:sx, 0:sy),  
     *       ftmp(0:sx, 0:sy),ftmp1(0:sx,0:sy)
      
      REAL*8 cc0,cc1,cc2,cc3,cc4,cc5
     
      INTEGER nts
      REAL*8 final_time,tfinal,cfl,dt
      REAL*8 ctime

      REAL*8 aux(0:sy,0:sx),aux1(0:sy,0:sx),aux2(0:sy,0:sx), 
     *       bux(0:sx,0:sy),bux1(0:sx,0:sy),bux2(0:sx,0:sy)

      REAL*8 WSAVEX(2*sx+15),WSAVEY(2*sy+15),
     *       fmx1(0:sx),fmx2(0:sx),fmy1(0:sy),fmy2(0:sy)


      REAL*8  dx,dy,t1,t2,t3,t4,t5,t6,xlen,ylen
      REAL*8  bphi
      
      REAL*8  phix,phiy,phixx,phiyy,phixy,
     *        phixxxx,phixxyy,phiyyyy,
     *        aaa1,aaa2,aaa3,aaa4
     
     
C Taking dd_x 
      DO j=0,n-1
      DO i=0,m-1
        aux(j,i)=dd(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (n,m,aux (0,0),aux2(0,0),n+1,WSAVEX)

      DO i=0,n-1

      aux1(i,0)=0.0D+0
      DO j=1,m-3,2
        aux1(i,j  )= aux(i,j+1)*fmx1(j) 

        aux1(i,j+1)= aux(i,j  )*fmx1(j+1)
      ENDDO
      aux1(i,m-1)=0.0D+0
      
      ENDDO

      CALL VRFFTB (n,m,aux1(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        fx(i,j)=aux1(j,i)
      ENDDO
      ENDDO

C obtain dd_xx 

      DO i=0,n-1

      aux1(i,0)=0.0D+0
      DO j=1,m-3,2
        aux1(i,j  )= aux(i,j  )*fmx2(j)

        aux1(i,j+1)= aux(i,j+1)*fmx2(j+1)
      ENDDO
      aux1(i,m-1)=0.0D+0

      ENDDO

       
      CALL VRFFTB (n,m,aux1(0,0),aux2(0,0),n+1,WSAVEX)

      DO j=0,n-1
      DO i=0,m-1
        dlap(i,j) = aux1(j,i)
      ENDDO
      ENDDO

C Taking dd_y 
      DO j=0,n-1
      DO i=0,m-1
        bux(i,j)=dd(i,j)
      ENDDO
      ENDDO

      CALL VRFFTF (m,n,bux (0,0),bux2(0,0),m+1,WSAVEY)

      DO i=0,m-1

      bux1(i,0)=0.0D+0
      DO j=1,n-3,2
        bux1(i,j  )= bux(i,j+1)*fmy1(j)

        bux1(i,j+1)= bux(i,j  )*fmy1(j+1)
      ENDDO
      bux1(i,n-1)=0.0D+0
      
      ENDDO

      CALL VRFFTB (m,n,bux1(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        fy(i,j)=bux1(i,j)
      ENDDO
      ENDDO

C obtain dd_yy 

      DO i=0,m-1

      bux1(i,0)=0.0D+0
      DO j=1,n-3,2
        bux1(i,j  )= bux(i,j  )*fmy2(j)

        bux1(i,j+1)= bux(i,j+1)*fmy2(j+1)
      ENDDO
      bux1(i,n-1)=0.0D+0

      ENDDO

       
      CALL VRFFTB (m,n,bux1(0,0),bux2(0,0),m+1,WSAVEY)

      DO j=0,n-1
      DO i=0,m-1
        dlap(i,j) = dlap(i,j) + bux1(i,j)
      ENDDO
      ENDDO
      
      
C Computation of cc5
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=fx(i,j)*fx(i,j) + fy(i,j)*fy(i,j)
        
        t1=t1 + t2*t2*t2
      ENDDO
      ENDDO
      cc5=dt*dx*dy*t1
      
C Computation of cc4
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=fx(i,j)*fx(i,j) + fy(i,j)*fy(i,j)
        t3=fx(i,j)*px(i,j) + fy(i,j)*py(i,j)
        
        t1=t1 + t2*t2*t3
      ENDDO
      ENDDO
      cc4=5.0D+0*dt*dx*dy*t1
      
C Computation of cc3
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=fx(i,j)*fx(i,j) + fy(i,j)*fy(i,j)
        t3=fx(i,j)*px(i,j) + fy(i,j)*py(i,j)
        
        t1=t1 + t2*t3*t3
      ENDDO
      ENDDO
      cc3=8.0D+0*dt*dx*dy*t1
      
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=fx(i,j)*fx(i,j) + fy(i,j)*fy(i,j)
        t3=px(i,j)*px(i,j) + py(i,j)*py(i,j)
        
        t1=t1 + t2*t2*t3
      ENDDO
      ENDDO
      cc3=cc3 + 2.0D+0*dt*dx*dy*t1
      
      
C Computation of cc2
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=fx(i,j)*fx(i,j) + fy(i,j)*fy(i,j)
        t3=fx(i,j)*px(i,j) + fy(i,j)*py(i,j)
        t4=px(i,j)*px(i,j) + py(i,j)*py(i,j)
        
        t1=t1 + t2*t3*t4
      ENDDO
      ENDDO
      cc2=6.0D+0*dt*dx*dy*t1
      
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t3=fx(i,j)*px(i,j) + fy(i,j)*py(i,j)
        
        t1=t1 + t3*t3*t3
      ENDDO
      ENDDO
      cc2=cc2 + 4.0D+0*dt*dx*dy*t1
      
      
C Computation of cc1
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=fx(i,j)*fx(i,j) + fy(i,j)*fy(i,j)
        t3=px(i,j)*px(i,j) + py(i,j)*py(i,j)
        
        t1=t1 + t2*t3*t3
      ENDDO
      ENDDO
      cc1=dt*dx*dy*t1
      
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=px(i,j)*px(i,j) + py(i,j)*py(i,j)
        t3=fx(i,j)*px(i,j) + fy(i,j)*py(i,j)
        
        t1=t1 + t2*t3*t3
      ENDDO
      ENDDO
      cc1=cc1 + 4.0D+0*dt*dx*dy*t1
      
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=dlap(i,j)*dlap(i,j) 
        
        t1=t1 + t2
      ENDDO
      ENDDO
      cc1=cc1 + dt*eps*eps*dx*dy*t1
      
c     t1=0.0D+0
c     DO j=0,n-1
c     DO i=0,m-1
c       t2=dd(i,j)*dd(i,j) 
        
c       t1=t1 + t2
c     ENDDO
c     ENDDO
c     cc1=cc1 + dx*dy*t1
      cc1=cc1 + 1.0D+0
      
C Computation of cc0
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t3=phi(i,j) - phi0(i,j)
        
        t1=t1 + t3*dd(i,j)
      ENDDO
      ENDDO
      cc0=dx*dy*t1
      
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=px(i,j)*px(i,j) + py(i,j)*py(i,j)
        t3=px(i,j)*fx(i,j) + py(i,j)*fy(i,j)
        
        t1=t1 + t2*t2*t3
      ENDDO
      ENDDO
      cc0=cc0 + dt*dx*dy*t1
      
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=dlap(i,j)*plap(i,j) 
        
        t1=t1 + t2
      ENDDO
      ENDDO
      cc0=cc0 + dt*eps*eps*dx*dy*t1
      
      t1=0.0D+0
      DO j=0,n-1
      DO i=0,m-1
        t2=dd(i,j)*plap1(i,j) 
        
        t1=t1 + t2
      ENDDO
      ENDDO
      cc0=cc0 + dt*dx*dy*t1
      

      RETURN
      END 



 
